from ddm.fast.commons import constants
from ddm.fast.commons.mass_widths import PATPAT_MASS_WIDTHS
from ddm.fast.cuts.cuts import CutTemplate as t, YearDependentCutTemplate as yt

#
# Cuts applied before DSA -> PAT replacement
#
prerepdict = {
    "ALL": t("1", 'all'),  # use with caution!
    "NONE": t("0", 'none'),
    "VTX": t("flag_PrimaryVertexFilter"),
    "NPP": t("evt_nParallelPairs<6", "n(parallel DSA muon pairs) < 6"),
    # "NS": t("({type}mu_nCSCStations[{id}]+{type}mu_nDTStations[{id}])>1"),
    # "NH": t("({type}mu_nCSCHits[{id}]+{type}mu_nDTHits[{id}])>12"),
    "HLT": t("evt_hltmatch", 'hlt matched'),  # HLT Matching
    "TRIG": t("Length$(trig_hlt_idx)", 'hlt trigger fired'),
    "L1TRIG": t("Length$(trig_l1tmu_idx)", 'l1t trigger fired'),
    "OMTF": t("abs(dsamu_eta)>0.8&&abs(dsamu_eta)<1.2", 'Overlap muons'),
    "BMTF": t("abs(dsamu_eta)<0.8", 'Barrel muons'),
    "EMTF": t("abs(dsamu_eta)>1.2", 'Endcap muons'),
    "2MUGENPT10": t('gen_pt[0]>10&&gen_pt[1]>10', 'gen p_{T} > 10'),
    "2MUGENPT20": t('gen_pt[0]>20&&gen_pt[1]>20', 'gen p_{T} > 20'),
    "L1T_12_5_OR_5_3_3": t("(((Sum$(sqrt(trig_l1tmu_px**2+trig_l1tmu_py**2)>=11.9&&trig_l1tmu_idx==0)>0&&Sum$(sqrt(trig_l1tmu_px**2+trig_l1tmu_py**2)>=4.9&&trig_l1tmu_idx==0)>1))||((Sum$(sqrt(trig_l1tmu_px**2+trig_l1tmu_py**2)>=4.9&&trig_l1tmu_idx==0)>0&&Sum$(sqrt(trig_l1tmu_px**2+trig_l1tmu_py**2)>=2.9&&trig_l1tmu_idx==0)>2)))", "L1T_12_5 OR L1T_5_3_3"),
    "L1T_15_5_OR_5_3_3": t("evt_L1T_15_5_OR_5_3_3==1", "L1T_15_5 OR L1T_5_3_3"),
    # "L1T_15_5_OR_5_3_3": Cut("(((Sum$(sqrt(trig_l1tmu_px**2+trig_l1tmu_py**2)>=14.9&&trig_l1tmu_idx==0)>0&&Sum$(sqrt(trig_l1tmu_px**2+trig_l1tmu_py**2)>=4.9&&trig_l1tmu_idx==0)>1))||((Sum$(sqrt(trig_l1tmu_px**2+trig_l1tmu_py**2)>=4.9&&trig_l1tmu_idx==0)>0&&Sum$(sqrt(trig_l1tmu_px**2+trig_l1tmu_py**2)>=2.9&&trig_l1tmu_idx==0)>2)))", "L1T_15_5 OR L1T_5_3_3"),
    "L1T_15_7_OR_5_3_3": t("(((Sum$(sqrt(trig_l1tmu_px**2+trig_l1tmu_py**2)>=14.9&&trig_l1tmu_idx==0)>0&&Sum$(sqrt(trig_l1tmu_px**2+trig_l1tmu_py**2)>=6.9&&trig_l1tmu_idx==0)>1))||((Sum$(sqrt(trig_l1tmu_px**2+trig_l1tmu_py**2)>=4.9&&trig_l1tmu_idx==0)>0&&Sum$(sqrt(trig_l1tmu_px**2+trig_l1tmu_py**2)>=2.9&&trig_l1tmu_idx==0)>2)))", "L1T_15_7 OR L1T_5_3_3"),
    "2018TRIG": ["L1T_15_5_OR_5_3_3", 'TRIG'],
    "L1PT2018": t("(((Sum$(strstr(trig_hlt_path[trig_l1tmu_idx],\"HLT_DoubleL2Mu23NoVtx_2Cha_v\")&&sqrt(trig_l1tmu_px**2+trig_l1tmu_py**2)>=14.99)>0)&&(Sum$(strstr(trig_hlt_path[trig_l1tmu_idx],\"HLT_DoubleL2Mu23NoVtx_2Cha_v\")&&sqrt(trig_l1tmu_px**2+trig_l1tmu_py**2)>=6.99)>1))||((Sum$(strstr(trig_hlt_path[trig_l1tmu_idx],\"HLT_DoubleL2Mu23NoVtx_2Cha_CosmicSeed_v\")&&sqrt(trig_l1tmu_px**2+trig_l1tmu_py**2)>=14.99)>0)&&(Sum$(strstr(trig_hlt_path[trig_l1tmu_idx],\"HLT_DoubleL2Mu23NoVtx_2Cha_CosmicSeed_v\")&&sqrt(trig_l1tmu_px**2+trig_l1tmu_py**2)>=6.99)>1)))"),
}

#
# DSA Muon Cuts
#
dsamudict = {
    "FPTE": t("({type}mu_ptError[{id}]/{type}mu_pt[{id}])<1."),
    "PT": t("{type}mu_pt[{id}]>10.", "p_{T} > 10 GeV"),
    "TRK": t("{type}mu_chi2[{id}]/{type}mu_ndof[{id}]<2.5"),
    "NDT": t("({type}mu_nDTHits[{id}]>18||{type}mu_nCSCHits[{id}]>0)"),
    "STATIME": t("({type}mu_closSTA_dR[{id}]>= 0.3||{type}mu_closSTA_timeAtIpInOut[{id}]<-998.||abs({type}mu_closSTA_timeAtIpInOut[{id}])<12.)"),
    "DSATIME": t("(abs({type}mu_timeAtIpInOut[{id}])<12.)"),
    "DIR": t("({type}mu_direction[{id}]==1)"),
    "DIR_RPC": t("({type}mu_direction_RPC[{id}]==1)"),
    "BARREL": t("(abs({type}mu_eta[{id}]) < 0.9)"),
    "OVERLAP": t("(abs({type}mu_eta[{id}]) >= 0.9 && {type}mu_eta[{id}]) < 1.2)"),
    "ENDCAP": t("(abs({type}mu_eta[{id}]) >= 1.2)"),
    "HLTPPMUONS": t('{type}mu_hltdim_pp_idx[{id}]!=100'),
    "HLTCOSMICMUONS": t('{type}mu_hltdim_cosmic_idx[{id}]!=100'),
    "DSAISO0p15": t("dim_mu{num}_iso<0.15", "I^{rel}_{STA} < 0.15"),
    "DSAISO0p1": t("dim_mu{num}_iso<0.1", "I^{rel}_{STA} < 0.1"),
    "DSAISO0p2": t("dim_mu{num}_iso<0.2", "I^{rel}_{STA} < 0.2"),
    "DSAISOLXY0p15": t("dim_isoLxy<0.15", "I^{rel}_{STA}(Lxy) < 0.15"),
    "DSAISOLXY0p1": t("dim_isoLxy<0.1", "I^{rel}_{STA}(Lxy) < 0.1"),
    "DSAISOLXY0p2": t("dim_isoLxy<0.2", "I^{rel}_{STA}(Lxy) < 0.2"),
    "DSAISOPmumu0p15": t("dim_isoPmumu<0.15", "I^{rel}_{STA}(p^{#mu#mu}) < 0.15"),
    "DSAISOPmumu0p1": t("dim_isoPmumu<0.1", "I^{rel}_{STA}(p^{#mu#mu}) < 0.1"),
    "DSAISOPmumu0p2": t("dim_isoPmumu<0.2", "I^{rel}_{STA}(p^{#mu#mu}) < 0.2"),
    "CDSAISO0p15": t("dsamu_cleanedIso[dim_mu{num}_idx]<0.15", "cleaned dsa rel iso < 0.15"),
}
dsadimdict = {
    "PSCORE0p1": t("dim_pscore>=0.1", "pscore #geq 0.1"),
    "PSCORE0p2": t("dim_pscore>=0.2", "pscore #geq 0.2"),
    "PSCORE0p25": t("dim_pscore>=0.25", "pscore #geq 0.25"),
    "PSCORE0p5": t("dim_pscore>=0.5", "pscore #geq 0.5"),
    "PSCORE0p9": t("dim_pscore>=0.9", "pscore #geq 0.9"),
    "ISOCRRLTN1": t("dim_isoLxy<(1-max(dim_mu1_iso, dim_mu2_iso))", "I^{rel}_{STA}(Lxy)<(1-max(I^{rel}_{STA}))"),
    "ISOCRRLTN0p4": t("dim_isoLxy<(0.4-0.4*max(dim_mu1_iso, dim_mu2_iso))", "I^{rel}_{STA}(Lxy)<(0.4-0.4max(I^{rel}_{STA}))"),
    "PRESEL": t("dim_DSAPreSel==1"),
    "SEL": t("dim_DSASel==1", "Full selection"),
    "SELPURE": t("dim_DSASel==1&&evt_nHYBSel==0&&evt_nPATSel==0", "Full selection, pure DSA-DSA dimuons events"),
    "SELCOM": t("dim_DSASel==1&&evt_nPATSel==0", "Full selection, taking care of category overlaps"),
    "REP": t("dim_type==0"),
    "DCA": t("dim_dca<15.", "DCA < 15"),
    "TMSDCA": t("dim_dca[dim_dim_idx]<15.", "DCA < 15"),
    "LXYE": t("(dim_Lxy_pv/dim_LxySig_pv)<99."),
    "TMSLXYE": t("(dim_Lxy_pv[dim_dim_idx]/dim_LxySig_pv[dim_dim_idx])<99."),
    "LXYE20": t("(dim_Lxy_pv/dim_LxySig_pv)<20."),
    "MAXPT25": t("max(dsamu_pt[{id1}],dsamu_pt[{id2}])>25", "max(p_{T}) > 25 GeV"),
    "MASS": t("dim_mass>10.", "mass > 10 GeV"),
    "MASSCOR": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>10.", "Corrected mass > 10 GeV"),
    "MASS6TO10": t("dim_mass<10.&&dim_mass>6.", "6 < mass < 10 GeV"),
    "MASS15": t("dim_mass>15.", "mass > 15 GeV"),
    "MASS20": t("dim_mass>20.", "mass > 20 GeV"),
    "MASS25": t("dim_mass>25.", "mass > 25 GeV"),
    "MASS30": t("dim_mass>30.", "mass > 30 GeV"),
    "MASS35": t("dim_mass>35.", "mass > 35 GeV"),
    "MASS40": t("dim_mass>40.", "mass > 40 GeV"),
    "MASS45": t("dim_mass>45.", "mass > 45 GeV"),
    "NOMASSWINDOW": t("1"),
    "QCDTFMASSWINDOW": t("dim_mass>20.&&dim_mass<80."),
    "RPVMASSWINDOW": t("dim_mass>15."),
    "RPVMASSWINDOW50": t("dim_mass>15&&correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>25."),
    "RPVMASSWINDOW100": t("dim_mass>15&&correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>50."),
    "RPVMASSWINDOW150": t("dim_mass>15&&correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>80."),
    "RPVMASSWINDOW175": t("dim_mass>15&&correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>90."),
    "RPVMASSWINDOW325": t("dim_mass>15&&correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>90."),
    "RPVMASSWINDOW500": t("dim_mass>15&&correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>210."),
    "RPVMASSWINDOW675": t("dim_mass>15&&correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>300."),
    #            "MASSWINDOW10": Cut("dim_mass>10.&&dim_mass<32."),
    "MASSWINDOW10": t("modelDependentDsaDsaMassCut(10, dim_mass)"),
    "MASSWINDOW20": t("modelDependentDsaDsaMassCut(20, dim_mass)"),
    "MASSWINDOW30": t("modelDependentDsaDsaMassCut(30, dim_mass)"),
    "MASSWINDOW40": t("modelDependentDsaDsaMassCut(40, dim_mass)"),
    "MASSWINDOW50": t("modelDependentDsaDsaMassCut(50, dim_mass)"),
    "MASSWINDOW60": t("modelDependentDsaDsaMassCut(60, dim_mass)"),
    "MASSWINDOW150": t("modelDependentDsaDsaMassCut(150, dim_mass)"),
    "MASSWINDOW350": t("modelDependentDsaDsaMassCut(350, dim_mass)"),
    "MASSWIN_10": ["MASSWINDOW10", ],
    "MASSWIN_20": ["MASSWINDOW20", ],
    "MASSWIN_30": ["MASSWINDOW30", ],
    "MASSWIN_40": ["MASSWINDOW40", ],
    "MASSWIN_50": ["MASSWINDOW50", ],
    "MASSWIN_60": ["MASSWINDOW60", ],
    "MASSWIN_150": ["MASSWINDOW150", ],
    "MASSWIN_350": ["MASSWINDOW350", ],
    "MASS10TO15": t("dim_mass>10&&dim_mass<=15", "10 GeV < m_{#mu#mu} < 15 GeV"),
    "MASS15TO32": t("dim_mass>15&&dim_mass<=32", "15 GeV < m_{#mu#mu} < 32 GeV"),
    "MASS15TO35": t("dim_mass>15&&dim_mass<=35", "15 GeV < m_{#mu#mu} < 35 GeV"),
    "MASS20TO60": t("dim_mass>20&&dim_mass<=60", "20 GeV < m_{#mu#mu} < 60 GeV"),
    "MASS25TO80": t("dim_mass>25&&dim_mass<=80", "25 GeV < m_{#mu#mu} < 80 GeV"),
    "MASS20TOINF": t("dim_mass>20", "m_{#mu#mu} > 20 GeV"),
    "MASS35TO60": t("dim_mass>35&&dim_mass<=60", "35 GeV < m_{#mu#mu} < 60 GeV"),
    "MASS35TOINF": t("dim_mass>35", "m_{#mu#mu} > 35 GeV"),
    "MASS60TOINF": t("dim_mass>60", "m_{#mu#mu} > 60 GeV"),

    "RPVMASSCOR": t("dim_mass>15."),
    "RPVMASSCOR15": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>15."),
    "RPVMASSCOR25": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>25."),
    "RPVMASSCOR50": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>50."),
    "RPVMASSCOR100": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>80."),

    "MASS1000": t("dim_mass>1000."),
    "MASSWINDOWHIGHMASS20": t("dim_mass>20.0"),
    "MASSWINDOWHIGHMASS35": t("dim_mass>35.0"),
    "SMEAREDMASSWINDOW10": t("modelDependentDsaDsaMassCut(10,   mass(smearDSApT(dsamu_pt[{id1}]), dsamu_eta[{id1}], dsamu_phi[{id1}], smearDSApT(dsamu_pt[{id2}]), dsamu_eta[{id2}], dsamu_phi[{id2}]))"),
    "SMEAREDMASSWINDOW20": t("modelDependentDsaDsaMassCut(20,   mass(smearDSApT(dsamu_pt[{id1}]), dsamu_eta[{id1}], dsamu_phi[{id1}], smearDSApT(dsamu_pt[{id2}]), dsamu_eta[{id2}], dsamu_phi[{id2}]))"),
    "SMEAREDMASSWINDOW30": t("modelDependentDsaDsaMassCut(30,   mass(smearDSApT(dsamu_pt[{id1}]), dsamu_eta[{id1}], dsamu_phi[{id1}], smearDSApT(dsamu_pt[{id2}]), dsamu_eta[{id2}], dsamu_phi[{id2}]))"),
    "SMEAREDMASSWINDOW40": t("modelDependentDsaDsaMassCut(40,   mass(smearDSApT(dsamu_pt[{id1}]), dsamu_eta[{id1}], dsamu_phi[{id1}], smearDSApT(dsamu_pt[{id2}]), dsamu_eta[{id2}], dsamu_phi[{id2}]))"),
    "SMEAREDMASSWINDOW50": t("modelDependentDsaDsaMassCut(50,   mass(smearDSApT(dsamu_pt[{id1}]), dsamu_eta[{id1}], dsamu_phi[{id1}], smearDSApT(dsamu_pt[{id2}]), dsamu_eta[{id2}], dsamu_phi[{id2}]))"),
    "SMEAREDMASSWINDOW60": t("modelDependentDsaDsaMassCut(60,   mass(smearDSApT(dsamu_pt[{id1}]), dsamu_eta[{id1}], dsamu_phi[{id1}], smearDSApT(dsamu_pt[{id2}]), dsamu_eta[{id2}], dsamu_phi[{id2}]))"),
    "SMEAREDMASSWINDOW150": t("modelDependentDsaDsaMassCut(150, mass(smearDSApT(dsamu_pt[{id1}]), dsamu_eta[{id1}], dsamu_phi[{id1}], smearDSApT(dsamu_pt[{id2}]), dsamu_eta[{id2}], dsamu_phi[{id2}]))"),
    "SMEAREDMASSWINDOW350": t("modelDependentDsaDsaMassCut(350, mass(smearDSApT(dsamu_pt[{id1}]), dsamu_eta[{id1}], dsamu_phi[{id1}], smearDSApT(dsamu_pt[{id2}]), dsamu_eta[{id2}], dsamu_phi[{id2}]))"),
    "CHI2": t("dim_normChi2<10.", "vtx. #chi^{2}/ndof < 10"),
    "TMSCHI2": t("dim_normChi2[dim_dim_idx]<10.", "vtx. #chi^{2}/ndof < 10"),
    "COSA": yt({
        2016: t("dim_cosAlpha>-0.8&&dim_cosAlphaOrig>-0.8", 'cos(#alpha) > #minus0.8'),
        2018: t("dim_cosAlpha>-0.9&&dim_cosAlphaOrig>-0.9", 'cos(#alpha) > #minus0.9'),
        2022: t("dim_cosAlpha>-0.9&&dim_cosAlphaOrig>-0.9", 'cos(#alpha) > #minus0.9')
    }),
    "TMSCOSA": yt({
        2022: t("dim_cosAlpha[dim_dim_idx]>-0.99&&dim_cosAlphaOrig[dim_dim_idx]>-0.99", 'cos(#alpha)>-0.99')
    }),
    "COSAm0p8": t("dim_cosAlpha>-0.8&&dim_cosAlphaOrig>-0.8", "cos(#alpha) > #minus0.8"),
    "COSAm0p9": t("dim_cosAlpha>-0.9&&dim_cosAlphaOrig>-0.9", "cos(#alpha) > #minus0.9"),
    "LXYS": t("dim_LxySig_pv>6."),
    "LXYS1": t("dim_LxySig_pv>1."),
    "TMSLXYS1": t("dim_LxySig_pv[dim_dim_idx]>1."),
    "LXYS3": t("dim_LxySig_pv>3."),
    "OS": t("!(dim_mu1_charge+dim_mu2_charge)", "OS"),
    "TMSOS": t("!(dim_mu1_charge[dim_mu1_idx[dim_dim_idx]-1000]+dim_mu2_charge[dim_mu2_idx[dim_dim_idx]-1000])", "OS"),
    "SS": t("(dim_mu1_charge+dim_mu2_charge)", "SS"),
    "DPHI": t("dim_deltaPhi<(0.25*pi)", "|#Delta#Phi| < #pi/4"),
    "TMSDPHI": t("dim_deltaPhi[dim_dim_idx]<(0.25*pi)", "|#Delta#Phi| < #pi/4"),
    "DPHI0p1": t("dim_deltaPhi<(0.1)", "|#Delta#Phi| < 0.1"),
    "DPHI0p2": t("dim_deltaPhi<(0.2)", "|#Delta#Phi| < 0.2"),
    "DPHI0p3": t("dim_deltaPhi<(0.3)", "|#Delta#Phi| < 0.3"),
    "DPHI0p4": t("dim_deltaPhi<(0.4)", "|#Delta#Phi| < 0.4"),
    "DPHI0p5": t("dim_deltaPhi<(0.5)", "|#Delta#Phi| < 0.5"),
    "DPHIb2": t("dim_deltaPhi<(pi/2.0)", "{:50}{:}".format("|#Delta#Phi*| = |#Delta#Phi|", "|#Delta#Phi| < #pi/2")),
    "DPHIb10": t("dim_deltaPhi<(pi/10.0)", "|#Delta#Phi| < #pi/10"),
    "DPHIb15": t("dim_deltaPhi<(pi/15.0)", "|#Delta#Phi| < #pi/15"),
    "DPHIb30": t("dim_deltaPhi<(pi/30.0)", "|#Delta#Phi| < #pi/30"),
    "iDPHIb2": t("dim_deltaPhi>(pi/2.0)", "{:50}{:}".format("|#Delta#Phi*| = #pi - |#Delta#Phi|", "|#Delta#Phi| > #pi/2")),
    "iDPHIb10": t("dim_deltaPhi>(pi - pi/10.0)", "|#Delta#Phi| > #pi - #pi/10"),
    "iDPHIb15": t("dim_deltaPhi>(pi - pi/15.0)", "|#Delta#Phi| > #pi - #pi/15"),
    "iDPHIb30": t("dim_deltaPhi>(pi - pi/30.0)", "|#Delta#Phi| > #pi - #pi/30"),
    "iDPHI": t("dim_deltaPhi>(0.5*pi)", "|#Delta#Phi| > #pi/2"),
    "iTMSDPHI": t("dim_deltaPhi[dim_dim_idx]>(0.5*pi)", "|#Delta#Phi| > #pi/2"),
    # "DPHI1"      : Cut("dim_deltaPhi<(0.25*pi)", "|#Delta#Phi| < #pi/4"),
    # "DPHI0"      : Cut("dim_deltaPhi<(0.5*pi)", "|#Delta#Phi| < #pi/2"),
    "IDPHI1": t("dim_deltaPhi>(0.25*pi)&&dim_deltaPhi<(0.5*pi)", "#pi/4 < |#Delta#Phi| < #pi/2"),
    # apply on top of IDPHI cut
    "IDPHI2": t("dim_deltaPhi>(0.5*pi)&&dim_deltaPhi<(0.75*pi)", "#pi/2 < |#Delta#Phi| < 3#pi/4"),
    "IDPHI3": t("dim_deltaPhi>(0.75*pi)&&dim_deltaPhi<pi", "|#Delta#Phi| > 3#pi/4"),
    "TIMEDIFF": t("(dsamu_dR_DSA_STA[{id1}]>=0.3||dsamu_dR_DSA_STA[{id2}]>=0.3||dsamu_timeAtIpInOut[{id1}]<-998.||dsamu_timeAtIpInOut[{id2}]<-998.||abs(dsamu_timeAtIpInOut[{id1}] - dsamu_timeAtIpInOut[{id2}])<20.)"),
    "DSATIMEDIFF": t("(abs(dsamu_timeAtIpInOut[{id1}] - dsamu_timeAtIpInOut[{id2}])<20.)"),
    "BBDSATIMEDIFF": t("_BBTD==1"),
    "BBDSAm0p9NS": t("(dim_BBDSA_pt<-998||!(dim_BBDSA_nStations>1))"),
    "SEG": t("_SEG==1"),
    "DETA": t("abs(dsamu_eta[{id1}] - dsamu_eta[{id2}]) < 0.10"),
    "DETASEG": t("_DESEG==1"),
    "SEGDETASEG": t("!((abs(dsamu_eta[{id1}] - dsamu_eta[{id2}]) < 0.10) && (dsamu_nDTStations[{id1}] + dsamu_nDTStations[{id2}] + dsamu_nCSCStations[{id1}] + dsamu_nCSCStations[{id2}]) <= 5) && ((dsamu_nDTStations[{id1}] + dsamu_nDTStations[{id2}] + dsamu_nCSCStations[{id1}] + dsamu_nCSCStations[{id2}]) >= 5)"),
    "DETANDT": t("_DENDT==1"),
    "IDETANDTIDETASEG": t("(!( ((dsamu_nDTHits[{id1}]>24 || dsamu_nCSCHits[{id1}]>0) && (dsamu_nDTHits[{id2}]>24 || dsamu_nCSCHits[{id2}]>0)) || abs(dsamu_eta[{id1}] - dsamu_eta[{id2}]) > 0.10 ) || ((abs(dsamu_eta[{id1}] - dsamu_eta[{id2}]) < 0.10) && (dsamu_nDTStations[{id1}] + dsamu_nDTStations[{id2}] + dsamu_nCSCStations[{id1}] + dsamu_nCSCStations[{id2}]) <= 5))"),
    "DETASR": ['DETANDT', 'DETASEG', 'SEG'],
    "DSA0": t("dim_type==0"),
    "DSA1": t("dim_type==1"),
    "DSA2": t("dim_type==2"),
    "DSA3": t("dim_type==3"),
    "DSA11": t("dim_type==11"),
    "DSA12": t("dim_type==12"),
    "DSA23": t("dim_type==23"),
    "ALLDSA": t("(dim_type==0||dim_type==1||dim_type==2||dim_type==3)"),
    "TMSZMASS": t("dim_mass[dim_dim_idx]>80.&&dim_mass[dim_dim_idx]<100.", "Drell-Yan enriched"),
    "DYTFPATCUTS": t("dim_mass[dim_dim_idx]>15.0&&dim_LxySig_pv[dim_dim_idx]<1.0&&patmu_trackIso[dim_mu1_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu1_idx[dim_dim_idx]-1000]<0.05&&patmu_trackIso[dim_mu2_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu2_idx[dim_dim_idx]-1000]<0.05"),
    # use with DSA3
    "DYCUTS": ["DSA3", "DYTFPATCUTS"],  # use with DSA3
    "DYTFPATCUTSLOOSE": t("dim_mass[dim_dim_idx]>15.0&&dim_LxySig_pv[dim_dim_idx]<3.0&&patmu_trackIso[dim_mu1_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu1_idx[dim_dim_idx]-1000]<0.05&&patmu_trackIso[dim_mu2_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu2_idx[dim_dim_idx]-1000]<0.05"),
    # use with DSA3
    "DYTFHYBCUTS": t("dim_mass[dim_dim_idx]>15.0&&dim_LxySig_pv[dim_dim_idx]<1.0&&patmu_trackIso[dim_mu2_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu2_idx[dim_dim_idx]-1000]<0.05"),
    # use with DSA11
    "NONISOPATDIM0p1": t("patmu_trackIso[dim_mu1_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu1_idx[dim_dim_idx]-1000]>0.1&&patmu_trackIso[dim_mu2_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu2_idx[dim_dim_idx]-1000]>0.1"),
    # use with DSA3
    "NONISOHYBDIM0p1": t("patmu_trackIso[dim_mu2_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu2_idx[dim_dim_idx]-1000]>0.1"),
    # use with DSA11
    "NONISOASSOCPATS": t("((dim_type==3&&patmu_trackIso[dim_mu1_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu1_idx[dim_dim_idx]-1000]>0.1&&patmu_trackIso[dim_mu2_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu2_idx[dim_dim_idx]-1000]>0.1)||(dim_type==11&&patmu_trackIso[dim_mu2_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu2_idx[dim_dim_idx]-1000]>0.1))"),
    # use with ALL (ie, any dim_type)
    "QCDTFPATMASSWINDOW10": t("dim_mass[dim_dim_idx]<10.0"),
    "QCDTFPATMASSWINDOW20": t("dim_mass[dim_dim_idx]<10.0"),
    "QCDTFPATMASSWINDOW30": t("dim_mass[dim_dim_idx]<15.0"),
    "QCDTFPATMASSWINDOW40": t("dim_mass[dim_dim_idx]<20.0"),
    "QCDTFPATMASSWINDOW50": t("dim_mass[dim_dim_idx]<20.0"),
    "QCDTFPATMASSWINDOW60": t("dim_mass[dim_dim_idx]<35.0"),
    "QCDTFPATMASSWINDOW150": t("dim_mass[dim_dim_idx]<35.0"),
    "QCDTFPATMASSWINDOW350": t("dim_mass[dim_dim_idx]<65.0"),
    # "CHARGEFLIPDSADSAPATPAT": Cut("dsamu_charge[dim_mu1_idx] * dsamu_charge[dim_mu2_idx] != patmu_charge[dim_mu1_idx[dim_dim_idx]-1000] * patmu_charge[dim_mu2_idx[dim_dim_idx]-1000]"),  # to be used with DSA3
    "NOCHARGEFLIPDSADSAPATPAT": t("(dsamu_charge[dim_mu1_idx] == patmu_charge[dim_mu1_idx[dim_dim_idx]-1000] && dsamu_charge[dim_mu2_idx] == patmu_charge[dim_mu2_idx[dim_dim_idx]-1000])"),
    # to be used with DSA3
    "SINGLECHARGEFLIPDSADSAPATPAT": t("((dsamu_charge[dim_mu1_idx] != patmu_charge[dim_mu1_idx[dim_dim_idx]-1000] && dsamu_charge[dim_mu2_idx] == patmu_charge[dim_mu2_idx[dim_dim_idx]-1000]) || (dsamu_charge[dim_mu1_idx] == patmu_charge[dim_mu1_idx[dim_dim_idx]-1000] && dsamu_charge[dim_mu2_idx] != patmu_charge[dim_mu2_idx[dim_dim_idx]-1000]))"),
    # to be used with DSA3
    "DOUBLECHARGEFLIPDSADSAPATPAT": t("(dsamu_charge[dim_mu1_idx] != patmu_charge[dim_mu1_idx[dim_dim_idx]-1000] && dsamu_charge[dim_mu2_idx] != patmu_charge[dim_mu2_idx[dim_dim_idx]-1000])"),
    # to be used with DSA3
    "CHARGEFLIPDSADSAHYBRID": t("dsamu_charge[dim_mu2_idx] != patmu_charge[dim_mu2_idx[dim_dim_idx]-1000]"),
    # to be used with DSA11
    "ISOHYBRID": t("dim_LxySig_pv[dim_dim_idx]<1.5&&patmu_trackIso[dim_mu2_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu2_idx[dim_dim_idx]-1000]<0.05"),
    # to be used with DSA11
    "NONISOHYBRID": t("patmu_trackIso[dim_mu2_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu2_idx[dim_dim_idx]-1000]>0.1"),
    # to be used with DSA11
    "GENMATCH": t('dim_mu1_gen_idx!=100&&dim_mu2_gen_idx!=100&&dim_gen_idx!=100'),
    "FID": t('gen_Lxy[dim_mu1_gen_idx]<500.&&gen_z[dim_mu1_gen_idx]<800.&&gen_pt[dim_mu1_gen_idx]>10.&&gen_pt[dim_mu2_gen_idx]>10.&&abs(gen_eta[dim_mu1_gen_idx])<2.&&abs(gen_eta[dim_mu2_gen_idx])<2.'),
    # "AntiSR"    : "(max(patmu_cleanedIso[dim_mu1_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu1_idx[dim_dim_idx]-1000],patmu_cleanedIso[dim_mu2_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu2_idx[dim_dim_idx]-1000])>0.1||dim_LxySig_pv[dim_dim_idx]<5)",  # cut originally used for Ivan's studies
    "DIMMULTGT0": t("evt_nDSASel>0", "dim. multiplicity #geq 1"),
    "DIMMULTGT1": t("evt_nDSASel>1", "dim. multiplicity #geq 2"),
    "LEADISO": t("(((dsamu_pt[dim_mu1_idx]>dsamu_pt[dim_mu2_idx])&&dsamu_PATcleanedIso[dim_mu1_idx]<0.15)||((dsamu_pt[dim_mu2_idx]>dsamu_pt[dim_mu1_idx])&&dsamu_PATcleanedIso[dim_mu2_idx]<0.15))", "Lead STA muon is isolated"),
    "BASE": constants.BASEDSACUTS,
    "SRCUTS": ["BASE", "DPHI", "OS", "LXYE20", "NDT", ],
    "SRCUTS_ISO": ["BASE", "OS", "LXYE20", "NDT", "DSAISO0p15"],
    "NONISO_CUTS": ["BASE", "DPHI", "OS", "LXYE20", "NDT", "IDSAISO0p15"],
    "SS_CUTS": ["SS", "DSAISO0p15"],
    "SS_IMASS_CUTS": ["SS", "IMASS"],
    ##            "COSMICCUTS" : ["REP", "LXYE", "iDPHI", "LXYS1", "CHI2", "DCA", "IDSATIME", "IDIR"],
    "COSMICCUTS": ['REP', 'LXYE', 'CHI2', 'ICOSA', 'DCA'],
    "COSMICCUTSTRING": t("1", "Cosmic enriched"),
    "COSMICCUTS_ISO": ['REP', 'LXYE', 'CHI2', 'ICOSA', 'DCA', 'DSAISO0p15'],
    #            "SRCUTS"     : ["BASE", "OS"],
    "DYCUTS": ['DSA3', 'LXYE', 'ITMSLXYS1', 'TMSZMASS', 'CHI2', 'DCA', 'DSATIME', 'DIR', 'DETASEG', 'DETANDT', 'SEG', 'BBDSATIMEDIFF', 'COSA', 'TMSOS'],
    "DYCUTS_ISO": ['DSA3', 'LXYE', 'ITMSLXYS1', 'TMSZMASS', 'CHI2', 'DCA', 'DSATIME', 'DIR', 'DETASEG', 'DETANDT', 'SEG', 'BBDSATIMEDIFF', 'COSA', 'TMSOS', 'CDSAISO0p15'],
    "DATACUTS_COSMIC": ["REP", "LXYE", "LXYS1", "CHI2", "ICOSA", "DCA", "iDPHI"],
    "DATACUTS_COSMIC_TRIG": ["REP", "LXYE", "LXYS1", "CHI2", "ICOSA", "DCA", "iDPHI", "HLTCOSMICL3Veto"],
    "SRCUTS_COSMIC": ["BASE", "DPHI", "OS", "LXYE20", "NDT", "LXYS1"],
    "SRCUTS_COSMIC_TRIG": ["BASE", "DPHI", "OS", "LXYE20", "NDT", "LXYS1", "HLTCOSMICL3Veto"],
    "CORRMASS20TO80": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>20&&correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)<80"),
    "CORRMASS25TO80": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>25&&correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)<80"),
    "CORRMASS30TO80": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>30&&correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)<80"),
    "CORRMASS30TO70": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>30&&correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)<70"),

    "CORRMASS50": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>50"),
    "CORRMASS50TO150": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>50&&correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)<150"),
    "CORRMASS60TO150": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>60&&correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)<150"),

    "CORRMASS60": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>60"),
    "CORRMASS70": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>70"),
    "CORRMASS80": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>80"),
    "CORRMASS90": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>90"),
    "CORRMASS100": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>100"),
    "CORRMASS100TO250": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>100&&correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)<250"),

    "CORRMASS10": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>10"),
    "UNBLIND30": t("(evt_event%10==3||evt_event%10==5||evt_event%10==7)"),
    "GENRECOVTXMATCH": t("sqrt((gen_x[dim_mu1_gen_idx]-dim_x)**2+(gen_y[dim_mu1_gen_idx]-dim_y)**2+(gen_z[dim_mu1_gen_idx]-dim_z)**2)<10.&&sqrt((gen_x[dim_mu1_gen_idx]-dim_x)**2+(gen_y[dim_mu1_gen_idx]-dim_y)**2+(gen_z[dim_mu1_gen_idx]-dim_z)**2)>0."),
    #            "GENRECOVTXMATCH": Cut("gen_Lxy[dim_mu1_gen_idx]<800 && gen_z[dim_mu1_gen_idx] < 1000."),
}

#
# Hybrid muon cuts
#
hybmudict = {
    "FPTE": t("({type}mu_ptError[{id}]/{type}mu_pt[{id}])<1.&&(dim_mu{num}_ptError/dim_mu{num}_pt<1.)"),
    "PT": t("{type}mu_pt[{id}]>10.", 'mu p_{T} > 10 GeV'),
    "NDT": t("({type}mu_nDTHits[{id}]>18||{type}mu_nCSCHits[{id}]>0)"),
    "MUGENMATCH": t("{type}mu_gen_idx[{id}]!=100"),
    "HLTPPPTGT28": t('{type}mu_hltdim_pp_idx[{id}]!=100&&sqrt(trig_hltmu_px[{type}mu_hltmu_pp_idx[{id}]]**2+trig_hltmu_py[{type}mu_hltmu_pp_idx[{id}]]**2)>28', 'hlt mu p_{T} > 28 GeV'),
    "HLTPPMUONS": t('{type}mu_hltdim_pp_idx[{id}]!=100'),
}

hybdsamudict = {
    "DSATRK": t("{type}mu_chi2[{id}]/{type}mu_ndof[{id}]<2.5"),
    "DSATIME": t("(abs({type}mu_timeAtIpInOut[{id}])<12.)"),
    "DIR": t("({type}mu_direction[{id}]==1)"),
}

hybpatmudict = {
    "ISPF": t("{type}mu_isPF[{id}]", 'isPF Muon'),
    "ISGLOB": t("{type}mu_isGlobal[{id}]"),
    "ISM": t("{type}mu_isMedium[{id}]"),
    "ISDISP": t("{type}mu_isDisp[{id}]"),
    "PATTRK": t("{type}mu_chi2[{id}]/{type}mu_ndof[{id}]<4.5", '#chi^{2}/ndof < 4.5'),
    "PATPROBTRK": t("TMath::Prob({type}mu_chi2[{id}],{type}mu_ndof[{id}])>5e-8", 'Prob. #chi^{2} > 5 #times 10^{-8}'),
    "NTRKLAYS": t('{type}mu_nTrackerLayers[{id}]>5', 'N(Tracker Layers) > 5'),
    "NTRKLAYSLXY": t('({type}mu_nTrackerLayers[{id}]+floor(dim_Lxy_pv/15))>5', 'N(Tracker Layers) + int(L_{xy}/15) > 5'),
    "HITSBEFVTX": t("dim_mu{num}_hitsBeforeVtx<6", 'hits before vertex < 6'),
    "D0SIGPV": t("{type}mu_d0sig_pv[{id}]>6", 'd_{0}/#sigma_{d_{0}} > 6'),
    "D0SIGPV4": t("{type}mu_d0sig_pv[{id}]>4", 'd_{0}/#sigma_{d_{0}} > 4'),
    "D0SIGPV3": t("{type}mu_d0sig_pv[{id}]>3", 'd_{0}/#sigma_{d_{0}} > 3'),
    "D0SIGPV2": t("{type}mu_d0sig_pv[{id}]>2", 'd_{0}/#sigma_{d_{0}} > 2'),
    "D0SIGPV1": t("{type}mu_d0sig_pv[{id}]>1", 'd_{0}/#sigma_{d_{0}} > 1'),
    "D0SIGPV0": t("{type}mu_d0sig_pv[{id}]>0", 'd_{0}/#sigma_{d_{0}} > 0'),
    "D0SIGPV0to1": t("{type}mu_d0sig_pv[{id}]>0&&{type}mu_d0sig_pv[{id}]< 1", '0 < d_{0}/#sigma_{d_{0}} < 1'),
    "D0SIGPV0to6": t("{type}mu_d0sig_pv[{id}]>0&&{type}mu_d0sig_pv[{id}]< 6", '0 < d_{0}/#sigma_{d_{0}} < 6'),
    "D0SIGPV2to6": t("{type}mu_d0sig_pv[{id}]>2&&{type}mu_d0sig_pv[{id}]< 6", '2 < d_{0}/#sigma_{d_{0}} < 6'),
    "D0SIGPV6to10": t("{type}mu_d0sig_pv[{id}]>6&&{type}mu_d0sig_pv[{id}]<10", '6 < d_{0}/#sigma_{d_{0}} < 10'),
    "D0SIGPV10to20": t("{type}mu_d0sig_pv[{id}]>10&&{type}mu_d0sig_pv[{id}]<20", '10 < d_{0}/#sigma_{d_{0}} < 20'),
    "D0SIGPV20ABOVE": t("{type}mu_d0sig_pv[{id}]>20", 'd_{0}/#sigma_{d_{0}} > 20'),
    "ISO": t("(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/{type}mu_pt[{id}])<0.075", 'iso < 0.075'),
    "ISO0P125": t("(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/{type}mu_pt[{id}])<0.125", 'iso < 0.125'),
    "ISO0P5": t("(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/{type}mu_pt[{id}])<0.5", 'iso < 0.5'),
    "ISO1P0": t("(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/{type}mu_pt[{id}])<1.0", 'iso < 1.0'),
    "DPHIMULXY": t("deltaphi({type}mu_phi[{id}],phi(dim_x,dim_y,dim_z,vtx_pv_x,vtx_pv_y,vtx_pv_z))<2.9", '|#phi_{#mu} #minus #phi_{Lxy}| < 2.9'),
}

hybdimdict = {
    "PSCORE0p1": t("dim_pscore>=0.1", "pscore #geq 0.1"),
    "PSCORE0p2": t("dim_pscore>=0.2", "pscore #geq 0.2"),
    "PSCORE0p25": t("dim_pscore>=0.25", "pscore #geq 0.25"),
    "PSCORE0p5": t("dim_pscore>=0.5", "pscore #geq 0.5"),
    "PSCORE0p9": t("dim_pscore>=0.9", "pscore #geq 0.9"),
    "ISOCRRLTN1": t("dim_isoLxy<(1-max(dim_mu1_iso, dim_mu2_cleanedIso/patmu_pt[dim_mu2_idx-1000]))", "I^{rel}_{STA}(Lxy)<(1-max(I^{rel}_{HYB}))"),
    "ISOCRRLTN0p4": t("dim_isoLxy<(0.4-0.4*max(dim_mu1_iso, dim_mu2_cleanedIso/patmu_pt[dim_mu2_idx-1000]))", "I^{rel}_{STA}(Lxy)<(0.4-0.4max(I^{rel}_{HYB}))"),
    "PRESEL": t("dim_HYBPreSel==1"),
    "SEL": t("dim_HYBSel==1", "Full selection"),
    "SELPURE": t("dim_HYBSel==1&&evt_nDSASel==0&&evt_nPATSel==0", "Full selection, pure DSA-PAT dimuons events"),
    "SELCOM": t("dim_HYBSel==1&&evt_nDSASel==0&&evt_nPATSel==0", "Full selection, taking care of category overlaps"),
    "REP": t("dim_type==12"),
    "INTHYB": t("(dim_type==13||dim_type==14)"),
    "DCA": t("dim_dca<15."),
    "LXYS": t("dim_LxySig_pv>3.", "L_{xy}/#sigma_{L_{xy}} > 3"),
    "LXYS0": t("dim_LxySig_pv>0."),
    "LXYS1": t("dim_LxySig_pv>1."),
    "LXYS2": t("dim_LxySig_pv>2."),
    "LXYS3": t("dim_LxySig_pv>3."),
    "LXY": t("dim_Lxy_pv<100."),
    "LXYE": t("(dim_Lxy_pv/dim_LxySig_pv)<99."),
    "LXYBEYTRA": t("max((dim_Lxy_pv-70 )*dim_LxySig_pv/dim_Lxy_pv,0)<10", 'L_{xy} beyond tracker < 10#sigma'),
    "MASS": t("dim_mass>10."),
    "MASS30": t("dim_mass>30."),
    "MASS35": t("dim_mass>35."),
    "MASS40": t("dim_mass>40."),
    "MASS45": t("dim_mass>45."),
    "MASS1000": t("dim_mass>1000."),
    "MASS0to10": t("dim_mass>0.&&dim_mass<10.", '0 < m_{#mu#mu} < 10 GeV'),
    "MASS10to30": t("dim_mass>10.&&dim_mass<30.", '10 < m_{#mu#mu} < 30 GeV'),
    "MASS30to60": t("dim_mass>30.&&dim_mass<60.", '30 < m_{#mu#mu} < 60 GeV'),
    "MASS60ABOVE": t("dim_mass>60.", 'm_{#mu#mu} > 60 GeV'),
    "MASS10to40": t("dim_mass>10.&&dim_mass<40.", '10 < m_{#mu#mu} < 40 GeV'),
    "MASS40to80": t("dim_mass>40.&&dim_mass<80.", '40 < m_{#mu#mu} < 80 GeV'),
    "MASS80ABOVE": t("dim_mass>80.", 'm_{#mu#mu} > 80 GeV'),
    "CHI2": t("dim_normChi2<20."),
    "COSA": yt({
        2016: t("dim_cosAlpha>-0.8&&dim_cosAlphaOrig>-0.8", 'cos(#alpha) > #minus 0.8'),
        2018: t("dim_cosAlpha>-0.9&&dim_cosAlphaOrig>-0.9", 'cos(#alpha) > #minus 0.9'),
        2022: t("dim_cosAlpha>-0.9&&dim_cosAlphaOrig>-0.9", 'cos(#alpha) > #minus 0.9')
    }),
    "COSAm0p8": t("dim_cosAlpha>-0.8&&dim_cosAlphaOrig>-0.8", "cos(#alpha) > #minus 0.8"),
    "COSAm0p9": t("dim_cosAlpha>-0.9&&dim_cosAlphaOrig>-0.9", "cos(#alpha) > #minus 0.9"),
    "COSAp0p9": t("dim_cosAlpha>0.9&&dim_cosAlphaOrig>0.9", "cos(#alpha) > 0.9"),
    "OS": t("!(dim_mu1_charge+dim_mu2_charge)", 'OS'),
    "SS": t("dim_mu1_charge+dim_mu2_charge", 'SS'),
    "DPHI": t("dim_deltaPhi<(0.5*pi)", ' |#Delta#Phi| < #pi/2'),
    "IDPHI": t("dim_deltaPhi>(0.5*pi)", ' |#Delta#Phi| > #pi/2'),
    # Define explicitly for the latex formatted title
    "DPHI1": t("dim_deltaPhi<(0.25*pi)", '0 < |#Delta#Phi| < #pi/4'),
    "DPHI2": t("dim_deltaPhi>=(0.25*pi)&&dim_deltaPhi<(0.5*pi)", '#pi/4 < |#Delta#Phi| < #pi/2'),
    # apply on top of IDPHI cut
    "DPHI3": t("dim_deltaPhi>=(0.5*pi)&&dim_deltaPhi<(0.75*pi)", '#pi/2 < |#Delta#Phi| < 3#pi/4'),
    "DPHI4": t("dim_deltaPhi>=(0.75*pi)&&dim_deltaPhi<pi", '3#pi/4 < |#Delta#Phi| < #pi'),
    "BBDSATIMEDIFF": t("(dim_BBDSA_pt<-998||!(dim_BBDSA_pt>10.&&dim_BBDSA_nStations>1&&abs(dsamu_timeAtIpInOut[dim_mu1_idx]-dim_BBDSA_timeAtIpInOut)>20.))"),
    "GENMATCH": t("dim_gen_idx!=100", 'Gen. matched'),
    "FID": t('gen_Lxy[dsamu_gen_idx[dim_mu1_idx]]<500.&&gen_z[dsamu_gen_idx[dim_mu1_idx]]<800.&&gen_pt[dsamu_gen_idx[dim_mu1_idx]]>10.&&gen_pt[patmu_gen_idx[dim_mu2_idx]]>10.&&abs(gen_eta[dsamu_gen_idx[dim_mu1_idx]])<2.&&abs(gen_eta[patmu_gen_idx[dim_mu2_idx-1000]])<2.'),
    "OS_DPHI": ["OS", "DPHI"],
    "OS_IDPHI": ["OS", "IDPHI"],
    "DYCONTROLLXYS": t("dim_LxySig_pv[dim_dim_idx]<3&&dim_mass[dim_dim_idx]>15.0&&patmu_trackIso[dim_mu1_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu1_idx[dim_dim_idx]-1000]<0.05&&patmu_trackIso[dim_mu2_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu2_idx[dim_dim_idx]-1000]<0.05", 'DYCONTROLLXYS'),
    "DYCONTROLD0SIG": t("patmu_d0sig_pv[dim_mu1_linkidx-1000]<1.5&&dim_mass[dim_dim_idx]>15.0&&patmu_trackIso[dim_mu1_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu1_idx[dim_dim_idx]-1000]<0.05&&patmu_trackIso[dim_mu2_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu2_idx[dim_dim_idx]-1000]<0.05", 'DYCONTROLD0SIG'),
    "QCDCONTROL": t("patmu_trackIso[dim_mu1_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu1_idx[dim_dim_idx]-1000]>0.1&&patmu_trackIso[dim_mu2_idx[dim_dim_idx]-1000]/patmu_pt[dim_mu2_idx[dim_dim_idx]-1000]>0.1", 'QCDCONTROL'),
    "QCDCONTROLTWO": t("dim_mu1_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2[dim_dim_idx]/patmu_pt[dim_mu1_idx[dim_dim_idx]-1000]>0.125&&dim_mu2_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2[dim_dim_idx]/patmu_pt[dim_mu2_idx[dim_dim_idx]-1000]>0.125", 'QCDCONTROLTWO'),
    "QCDCONTROLONE": t("max(dim_mu1_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2[dim_dim_idx]/patmu_pt[dim_mu1_idx[dim_dim_idx]-1000],dim_mu2_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2[dim_dim_idx]/patmu_pt[dim_mu2_idx[dim_dim_idx]-1000]  )>0.125", 'QCDCONTROLONE'),
    "DSAPATD0SIG": t("patmu_d0sig_pv[dim_mu1_linkidx-1000]>6", 'DSA assoc. PAT d_{0}/#sigma_{d_{0}} > 6'),
    "MASSWIN_10": t("dim_mass>10.0&&dim_mass<14.0"),
    "MASSWIN_13": t("dim_mass>10.0&&dim_mass<17.0"),
    "MASSWIN_16": t("dim_mass>11.0&&dim_mass<21.0"),
    "MASSWIN_20": t("dim_mass>14.0&&dim_mass<26.0"),
    "MASSWIN_25": t("dim_mass>17.0&&dim_mass<33.0"),
    "MASSWIN_30": t("dim_mass>20.0&&dim_mass<40.0"),
    "MASSWIN_35": t("dim_mass>24.0&&dim_mass<46.0"),
    "MASSWIN_40": t("dim_mass>28.0&&dim_mass<52.0"),
    "MASSWIN_45": t("dim_mass>32.0&&dim_mass<58.0"),
    "MASSWIN_50": t("dim_mass>36.0&&dim_mass<64.0"),
    "MASSWIN_55": t("dim_mass>39.0&&dim_mass<71.0"),
    "MASSWIN_60": t("dim_mass>42.0&&dim_mass<78.0"),
    "MASSWIN_80": t("dim_mass>56.0&&dim_mass<104.0"),
    "MASSWIN_150": t("dim_mass>95.0&&dim_mass<205.0"),
    "MASSWIN_350": t("dim_mass>150.0"),
    "BASE": constants.BASEHYBCUTS,
    "DIMMULTGT0": t("evt_nHYBSel>0", "dim. multiplicity #geq 1"),
    "DIMMULTGT1": t("evt_nHYBSel>1", "dim. multiplicity #geq 2"),
}

#
# PAT Muon Cuts
#
patmudict = {
    "ISTM": t("{type}mu_isTracker[{id}]"),
    "ISDISP": t("{type}mu_isDisp[{id}]"),
    "ISNOTDISP": t("{type}mu_isDisp[{id}]==0"),
    "TKISO": t("({type}mu_cleanedIso[{id}]/{type}mu_pt[{id}])<0.1", 'iso < 0.1'),
    "HB4V": t("dim_mu{num}_hitsBeforeVtx<3", "hits before vertex < 3"),
    "ISO": t("(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/{type}mu_pt[{id}])<0.075", 'iso < 0.075'),
    "ISO1P0": t("(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/{type}mu_pt[{id}])<1.0", 'iso < 1.0'),
    "ISO0P2": t("(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/{type}mu_pt[{id}])<0.2", 'iso < 0.2'),
    "ISO0P15": t("(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/{type}mu_pt[{id}])<0.15", 'iso < 0.15'),
    "ISO0P5": t("(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/{type}mu_pt[{id}])<0.5", 'iso < 0.5'),
    "ISO0P05": t("(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/{type}mu_pt[{id}])<0.05", 'iso < 0.05'),
    "ISO0P1": t("(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/{type}mu_pt[{id}])<0.1", 'track-based iso < 0.1'),
    "ISO0P075": t("(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/{type}mu_pt[{id}])<0.075", 'iso < 0.075'),
    "ISOGT0P075": t("(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/{type}mu_pt[{id}])>0.075", 'iso > 0.075'),
    "TKSTAT": t("{type}mu_nMatchedStations[{id}]>1"),
    "FPTE": t("({type}mu_ptError[{id}]/{type}mu_pt[{id}])<1."),
    "PT": t("{type}mu_pt[{id}]>10.", 'p_{T} > 10 GeV'),
    "STAPT": t("dsamu_pt > 10.", 'STA p_{T} > 10 GeV'),
    "STAETA": t("abs(dsamu_eta) < 2.", 'STA |#eta| < 2.0'),
    "PT23": t("{type}mu_pt[{id}]>23.", 'p_{T} > 23 GeV'),
    "PTLT30": t("{type}mu_pt[{id}]<30."),
    "PTGT50": t("{type}mu_pt[{id}]>50."),
    "NTRKLAYS": t('{type}mu_nTrackerLayers[{id}]>3', 'N(Tracker Layers) > 3'),
    "NTRKLAYSLXY": t('({type}mu_nTrackerLayers[{id}]+floor(dim_Lxy_pv/15))>5', 'N(Tracker Layers) + floor(Lxy/15) > 5'),
    "MAXTWOPT15-POSTRETUPLE": t("!(({id}<2)&&({type}mu_pt[{id}]<=15.))", "max two p_{T} > 15"),
    "MAXTWOPT15-ONEDIM": t("!((Length$(dim_mass)==1)&&({id}<2)&&({type}mu_pt[{id}]<=15.))", "max two p_{T} > 15"),
    "PT15": t("{type}mu_pt[{id}]>15."),
    "PT25": t("{type}mu_pt[{id}]>25."),
    "MIDPT": t("{type}mu_pt[{id}]>10.&&{type}mu_pt[{id}]<30.", "10 < p_{T} < 30 GeV"),
    "HIGHPT": t("{type}mu_pt[{id}]>100.", "p_{T} > 100 GeV"),
    "D0SIGPV": t("abs({type}mu_d0sig_pv[{id}])>6", "d_{0}/#sigma_{d_{0}} > 6"),
    "HB4V_1": t("dim_mu{num}_hitsBeforeVtx<1", "hits before vertex < 1"),
    "HB4V_2": t("dim_mu{num}_hitsBeforeVtx<2", "hits before vertex < 2"),
    "HB4V_3": t("dim_mu{num}_hitsBeforeVtx<3", "hits before vertex < 3"),
    "HB4V_4": t("dim_mu{num}_hitsBeforeVtx<4", "hits before vertex < 4"),
    "HB4V_6": t("dim_mu{num}_hitsBeforeVtx<6", "hits before vertex < 6"),
    "PXLGT0": t("{type}mu_nPixelHits[{id}]>0", "pixel hits > 0"),
    "SUMPT30": t("patmu_pt[{id1}]+patmu_pt[{id2}]>30", "sum mu p_{T} > 30"),
    "SUMPT40": t("patmu_pt[{id1}]+patmu_pt[{id2}]>40", "sum mu p_{T} > 40"),
    "DTKISO": t("(dim_mu{num}_cleanedIso/{type}mu_pt[{id}])<0.1"),
    "TKISO05": t("({type}mu_cleanedIso[{id}]/{type}mu_pt[{id}])<0.05"),
    "TKISO5": t("({type}mu_cleanedIso[{id}]/{type}mu_pt[{id}])<0.5"),
    "TWOMEDISO0P5": t("(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/{type}mu_pt[{id}])>0.1&&(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/{type}mu_pt[{id}])<0.5", '0.1 < iso < 0.5'),
    "TWOMEDISO1P0": t("(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/{type}mu_pt[{id}])>0.1&&(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/{type}mu_pt[{id}])<1.0", '0.1 < iso < 1.0'),
    "REFD0SIGPV": t("dim_mu{num}_d0sig_pv>4"),
    "MAXDZSIGPV": t("max(dim_mu1_dzsig_pv),dim_mu2_dzsig_pv)>4"),
    "DZSIGPV": t("dim_mu{num}_dzsig_pv>0.5"),
    "D0SIGBS": t("dim_mu{num}_d0sig_bs>5."),
    "ISPF": t("{type}mu_isPF[{id}]", 'isPF Muon'),
    "ISGLOB": t("{type}mu_isGlobal[{id}]"),
    "KCHI2": t("{type}mu_kinkchi2[{id}]<20"),
    "ISM": t("{type}mu_isMedium[{id}]"),
    "NDT": t("({type}mu_nDTHits[{id}]>18||{type}mu_nCSCHits[{id}]>0)"),
    "PTOLD": t("sqrt({type}mu_px[{id}]^2+{type}mu_py[{id}]^2)>30."),
    "HPT": t("{type}mu_hpur[{id}]", 'isHighPurity Muon'),
    "DZSIG": t("dim_mu{num}_dzsig_pv>0.1"),
    "PFISO4R4": t("{type}mu_pfIso04[{id}]/{type}mu_pt[{id}]<0.4"),
    "CHISO1R4": t("{type}mu_chHadPtR04[{id}]/{type}mu_pt[{id}]<0.1"),
    "CHISO15R4": t("{type}mu_chHadPtR04[{id}]/{type}mu_pt[{id}]<0.15"),
    "NHISOR4": t("{type}mu_neutHadEtR04[{id}]/{type}mu_pt[{id}]<0.4"),
    "PHOISOR4": t("{type}mu_photonEtR04[{id}]/{type}mu_pt[{id}]<0.4"),
    "PFISO4R3": t("{type}mu_pfIso03[{id}]/{type}mu_pt[{id}]<0.4"),
    "PFISO2R3": t("{type}mu_pfIso03[{id}]/{type}mu_pt[{id}]<0.2"),
    "PFISO15R3": t("{type}mu_pfIso03[{id}]/{type}mu_pt[{id}]<0.15", "pf iso < 0.15"),
    "CHISO1R3": t("{type}mu_chHadPtR03[{id}]/{type}mu_pt[{id}]<0.1"),
    "CHISO15R3": t("{type}mu_chHadPtR03[{id}]/{type}mu_pt[{id}]<0.15"),
    "NHISOR3": t("{type}mu_neutHadEtR03[{id}]/{type}mu_pt[{id}]<0.4"),
    "PHOISOR3": t("{type}mu_photonEtR03[{id}]/{type}mu_pt[{id}]<0.4"),
    "NOTKISO": t('({type}mu_pfIso03[{id}]-{type}mu_chHadPtR03[{id}])/{type}mu_pt[{id}]<0.4'),
    "UTKISO": t("({type}mu_trackIso[{id}]/{type}mu_pt[{id}])<0.1"),
    "ETA_0_0P2": t("abs({type}mu_eta[{id}])<0.2"),
    "ETA_0_0P5": t("abs({type}mu_eta[{id}])<0.5"),
    "ETAGT1P5": t("abs({type}mu_eta[{id}])>1.5"),
    "D0SIGPV0": t("{type}mu_d0sig_pv[{id}]>0", "d_{0}/#sigma_{d_{0}} > 0"),
    "D0SIGPV1": t("{type}mu_d0sig_pv[{id}]>1", "d_{0}/#sigma_{d_{0}} > 1"),
    "D0SIGPV2": t("{type}mu_d0sig_pv[{id}]>2", "d_{0}/#sigma_{d_{0}} > 2"),
    "D0SIGPV3": t("{type}mu_d0sig_pv[{id}]>3", "d_{0}/#sigma_{d_{0}} > 3"),
    "D0SIGPV4": t("{type}mu_d0sig_pv[{id}]>4", "d_{0}/#sigma_{d_{0}} > 4"),
    "D0SIGPV5p5": t("{type}mu_d0sig_pv[{id}]>5.5"),
    "D0SIGPV6": t("{type}mu_d0sig_pv[{id}]>6", "d_{0}/#sigma_{d_{0}} > 6"),
    "D0SIGPV8": t("{type}mu_d0sig_pv[{id}]>8", "d_{0}/#sigma_{d_{0}} > 8"),
    "D0SIGPV10": t("{type}mu_d0sig_pv[{id}]>10", "d_{0}/#sigma_{d_{0}} > 10"),
    "D0SIGPV15": t("{type}mu_d0sig_pv[{id}]>15.", "d_{0}/#sigma_{d_{0}} > 15"),
    "D0SIGPV20": t("{type}mu_d0sig_pv[{id}]>20.", "d_{0}/#sigma_{d_{0}} > 20"),
    "D0SIGPV30": t("{type}mu_d0sig_pv[{id}]>30.", "d_{0}/#sigma_{d_{0}} > 30"),
    "D0SIGPV2TO3": t("{type}mu_d0sig_pv[{id}]>2&&{type}mu_d0sig_pv[{id}]<=3", "2 < d_{0}/#sigma_{d_{0}} #leq 3"),
    "D0SIGPV2TO4": t("{type}mu_d0sig_pv[{id}]>2&&{type}mu_d0sig_pv[{id}]<=4", "2 < d_{0}/#sigma_{d_{0}} #leq 4"),
    "D0SIGPV1TO3": t("{type}mu_d0sig_pv[{id}]>1&&{type}mu_d0sig_pv[{id}]<=3", "1 < d_{0}/#sigma_{d_{0}} #leq 3"),
    "D0SIGPV0TO2": t("{type}mu_d0sig_pv[{id}]>0&&{type}mu_d0sig_pv[{id}]<=2", "0 < d_{0}/#sigma_{d_{0}} #leq 2"),
    "D0SIGPV2TO6": t("{type}mu_d0sig_pv[{id}]>2&&{type}mu_d0sig_pv[{id}]<=6", "2 < d_{0}/#sigma_{d_{0}} #leq 6"),
    "D0SIGPV4TO6": t("{type}mu_d0sig_pv[{id}]>4&&{type}mu_d0sig_pv[{id}]<=6", "4 < d_{0}/#sigma_{d_{0}} #leq 6"),
    "D0SIGPV6TO10": t("{type}mu_d0sig_pv[{id}]>6&&{type}mu_d0sig_pv[{id}]<=10", "6 < d_{0}/#sigma_{d_{0}} #leq 10"),
    "GEND0LT0P001": t('{type}mu_gen_idx[{id}]!=100&&gen_d0[{type}mu_gen_idx[{id}]]<0.001', 'gen d_{0} < 0.001 [cm]'),
    "GEND0LT0P01": t('{type}mu_gen_idx[{id}]!=100&&gen_d0[{type}mu_gen_idx[{id}]]<0.01', 'gen d_{0} < 0.01 [cm]'),
    "GEND0LT0P1": t('{type}mu_gen_idx[{id}]!=100&&gen_d0[{type}mu_gen_idx[{id}]]<0.1', 'gen d_{0} < 0.1 [cm]'),
    "GEND0LT1P0": t('{type}mu_gen_idx[{id}]!=100&&gen_d0[{type}mu_gen_idx[{id}]]<1.0', 'gen d_{0} < 1. [cm]'),
    "GEND0ALL": t('{type}mu_gen_idx[{id}]!=100', 'all'),
    "PT15HLTMATCH": t('({type}mu_pt[{id}]>15.||({type}mu_hltdim_pp_idx[{id}]==100&&{type}mu_hltdim_cosmic_idx[{id}]==100))', 'hlt matched mu > 15 GeV'),
    "PT20HLTMATCH": t('({type}mu_pt[{id}]>20.||({type}mu_hltdim_pp_idx[{id}]==100&&{type}mu_hltdim_cosmic_idx[{id}]==100))', 'hlt matched mu > 20 GeV'),
    "PT25HLTMATCH": t('({type}mu_pt[{id}]>25.||({type}mu_hltdim_pp_idx[{id}]==100&&{type}mu_hltdim_cosmic_idx[{id}]==100))', 'hlt matched mu > 25 GeV'),
    "HLTMUONS": t('({type}mu_hltdim_pp_idx[{id}]!=100||{type}mu_hltdim_cosmic_idx[{id}]!=100)'),
    "HLTPPMUONS": t('{type}mu_hltdim_pp_idx[{id}]!=100'),
    "HLTCOSMICMUONS": t('{type}mu_hltdim_cosmic_idx[{id}]!=100'),
    "HLTPPPTGT28": t('{type}mu_hltdim_pp_idx[{id}]!=100&&sqrt(trig_hltmu_px[{type}mu_hltmu_pp_idx[{id}]]**2+trig_hltmu_py[{type}mu_hltmu_pp_idx[{id}]]**2)>28', 'hlt mu p_{T} > 28 GeV'),
    "HLTCOSMICPTGT28": t('{type}mu_hltdim_cosmic_idx[{id}]!=100&&sqrt(trig_hltmu_px[{type}mu_hltmu_cosmic_idx[{id}]]**2+trig_hltmu_py[{type}mu_hltmu_cosmic_idx[{id}]]**2)>28', 'hlt mu p_{T} > 28 GeV'),
    'TAUDECAY': t('abs(gen_pdgID[gen_mother[{type}mu_gen_idx[{id}]]])==15', '#tau decay'),
    'ZDECAY': t('(abs(gen_pdgID[gen_mother[{type}mu_gen_idx[{id}]]])==23||gen_pdgID[gen_status[{type}mu_gen_idx[{id}]]]==21)', 'Z decay'),
    "POG_TKISO": t("({type}mu_trackIso[{id}]/{type}mu_pt[{id}])<0.075", 'default iso < 0.075'),
    "POG_ISO": t("(dim_mu{num}_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/{type}mu_pt[{id}])<0.075", 'modified iso < 0.075'),
    "PAT_SUB": t("({type}mu_isTracker[{id}])&&({type}mu_nMatchedStations[{id}]>1)&&(({type}mu_ptError[{id}]/{type}mu_pt[{id}])<1.)", 'PAT Muon (w/o d_{0} or p_{T} cut)'),
    "PAT": t("({type}mu_isTracker[{id}])&&({type}mu_nMatchedStations[{id}]>1)&&(({type}mu_ptError[{id}]/{type}mu_pt[{id}])<1.)&&({type}mu_pt[{id}]>10.)", 'PAT Muon (w/o d_{0} cut)'),
    "D0PV0p02": t("abs({type}mu_d0_pv[{id}])>0.02"),

}
patdimdict = {
    "PSCORE0p1": t("dim_pscore>=0.1", "pscore #geq 0.1"),
    "PSCORE0p2": t("dim_pscore>=0.2", "pscore #geq 0.2"),
    "PSCORE0p25": t("dim_pscore>=0.25", "pscore #geq 0.25"),
    "PSCORE0p5": t("dim_pscore>=0.5", "pscore #geq 0.5"),
    "PSCORE0p9": t("dim_pscore>=0.9", "pscore #geq 0.9"),
    "ISOCRRLTN1": t("dim_isoLxy<(1-max(dim_mu1_cleanedIso/patmu_pt[dim_mu1_idx-1000], dim_mu2_cleanedIso/patmu_pt[dim_mu2_idx-1000]))", "I^{rel}_{STA}(Lxy)<(1-max(I^{rel}_{TMS}))"),
    "ISOCRRLTN0p4": t("dim_isoLxy<(0.4-0.4*max(dim_mu1_cleanedIso/patmu_pt[dim_mu1_idx-1000], dim_mu2_cleanedIso/patmu_pt[dim_mu2_idx-1000]))", "I^{rel}_{STA}(Lxy)<(0.4-0.4max(I^{rel}_{TMS}))"),
    ## rntuple cuts
    "_REP": t("_REP==1", "REP"),
    "_LXYE": t("_LXYE==1", "LXYE"),
    "_MASS": t("_MASS==1", "MASS"),
    "_CHI2": t("_CHI2==1", "CHI2"),
    "_COSA": t("_COSA==1", "COSA"),
    "_LXYS": t("_LXYS==1", "LXYS"),
    "_DCA": t("_DCA==1", "DCA"),
    "_OS": t("_OS==1", "OS"),
    "_DPHI": t("_DPHI==1", "LXYS"),
    "_D0SIG": t("_D0SIG==1", "D0SIG"),
    "_ISO": t("_ISO==1", "ISO"),
    "_PXL": t("_PXL==1", "PXL"),
    "_MAXPT": t("_MAXPT==1", "MAXPT"),
    "_HB4V": t("_HB4V==1", "HB4V"),
    "_NLLXY": t("_NLLXY==1", "NLLXY"),
    #####
    "PRESEL": t("dim_PATPreSel==1"),
    "SEL": t("dim_PATSel==1", "Full selection"),
    "SELPURE": t("dim_PATSel==1&&evt_nDSASel==0&&evt_nHYBSel==0", "Full selection, pure PAT-PAT dimuons events"),
    "SELCOM": t("dim_PATSel==1", "Full selection, taking care of category overlaps"),
    "REP": t("dim_type==23"),
    "PXL": t("abs(patmu_nPixelHits[{id1}]-patmu_nPixelHits[{id2}])<3", "#Delta (pixel hits) < 3"),
    "PXLLT2": t("abs(patmu_nPixelHits[{id1}]-patmu_nPixelHits[{id2}])<2"),
    "PXLLT4": t("abs(patmu_nPixelHits[{id1}]-patmu_nPixelHits[{id2}])<4"),
    "LXYE": t("(dim_Lxy_pv/dim_LxySig_pv)<99."),
    "LXYS": t("dim_LxySig_pv>6.", "L_{xy}/#sigma_{L_{xy}} > 6"),
    "DPHI1": t("dim_deltaPhi<(0.25*pi)", '|#Delta#Phi| < #pi/4'),
    "DPHI0p1": t("dim_deltaPhi<(0.1)", '|#Delta#phi| < 0.1'),
    "DPHIb30": t("dim_deltaPhi<(pi/30)", '|#Delta#Phi| < #pi/30'),
    "DPHI2": t("dim_deltaPhi>=(0.25*pi)&&dim_deltaPhi<(0.5*pi)", '#pi/4 #leq |#Delta#Phi| < #pi/2'),  # apply on top of IDPHI cut
    "DPHI3": t("dim_deltaPhi>=(0.5*pi)&&dim_deltaPhi<(0.75*pi)", '#pi/2 #leq |#Delta#Phi| < 3#pi/4'),
    "DPHI4": t("dim_deltaPhi>=(0.75*pi)&&dim_deltaPhi<pi", '|#Delta#Phi| > 3#pi/4'),
    "DPHI4T": t("dim_deltaPhi>=(3.04)&&dim_deltaPhi<pi", '|#Delta#phi| > 3#pi/4'),  # Tighter version of DPHI4
    "DPHIPIBY30": t("dim_deltaPhi<(pi/30.)", '|#Delta#Phi| < #pi/30'),
    "DPHIPIBY30OPP": t("dim_deltaPhi>=(29.*pi/30.)&&dim_deltaPhi<pi", '|#Delta#Phi| > 29#pi/30'),
    "DPHI0P1": t("dim_deltaPhi<(0.1)", '|#Delta#Phi| < 0.1'),
    "DPHI0P4": t("dim_deltaPhi<(0.4)", '|#Delta#Phi| < 0.4'),
    "DPHIPIBY8": t("dim_deltaPhi<(0.125*pi)", '|#Delta#Phi| < #pi/8'),
    "MASS": t("dim_mass>10.", "mass > 10 GeV"),
    "MASSCOR": t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>10.", "Corrected mass > 10 GeV"),
    "CHI2": t("dim_normChi2<10.", 'vtx #chi^{2} < 10'),
    "CHI2LT20": t("dim_normChi2<20", "vtx #chi^{2} < 20"),
    "CHI2LT30": t("dim_normChi2<30", "vtx #chi^{2} < 30"),
    "CHI2LT50": t("dim_normChi2<50", "vtx #chi^{2} < 50"),
    "CHI2CTRL": t("dim_normChi2>20.&&dim_normChi2<40."),
    "UNBLIND10PERCENT": t("evt_event%10==3", "Event number ends in 3"),
    "UNBLIND30PERCENT": t("(evt_event%10==3||evt_event%10==5||evt_event%10==7)", "Event number ends in 3, 5 ,7"),
    "COSA": yt({
        2016: t("dim_cosAlpha>-0.8&&dim_cosAlphaOrig>-0.8", 'cos(#alpha)>-0.8'),
        2018: t("dim_cosAlpha>-0.99&&dim_cosAlphaOrig>-0.99", 'cos(#alpha)>-0.99'),
        2022: t("dim_cosAlpha>-0.99&&dim_cosAlphaOrig>-0.99", 'cos(#alpha)>-0.99')
    }),
    "PARALLEL": t("dim_cosAlpha>0.999999&&dim_cosAlphaOrig>0.999999", 'cos(#alpha)>0.999999'),
    "COSA8": t("dim_cosAlpha>-0.8&&dim_cosAlphaOrig>-0.8", 'cos(#alpha)>-0.8'),
    "COSA9": t("dim_cosAlpha>-0.9&&dim_cosAlphaOrig>-0.9", 'cos(#alpha)>-0.9'),
    "COSA95": t("dim_cosAlpha>-0.95&&dim_cosAlphaOrig>-0.95", 'cos(#alpha)>-0.95'),
    "COSA99": t("dim_cosAlpha>-0.99&&dim_cosAlphaOrig>-0.99", 'cos(#alpha)>-0.99'),
    "COSA9998": t("dim_cosAlpha>-0.9998&&dim_cosAlphaOrig>-0.9998", 'cos(#alpha)>-0.9998'),
    "OS": t("!(dim_mu1_charge+dim_mu2_charge)", 'OS'),
    "SS": t("dim_mu1_charge+dim_mu2_charge", 'SS'),
    "DPHI": t("dim_deltaPhi<(0.5*pi)", '|#Delta#Phi| < #pi/2'),
    "iDPHI": t("dim_deltaPhi>=(0.5*pi)", '|#Delta#Phi| > #pi/2'),
    "DCA": t("dim_dca<50."),
    "MINPF": t("min(patmu_pfIso03[{id1}]/patmu_pt[{id1}],patmu_pfIso03[{id2}]/patmu_pt[{id2}])<0.1"),
    "MINCH": t("min(patmu_chHadPtR03[{id1}]/patmu_pt[{id1}],patmu_chHadPtR03[{id2}]/patmu_pt[{id2}])<0.05"),
    "MINNOTK": t("min((patmu_pfIso03[{id1}]-patmu_chHadPtR03[{id1}])/patmu_pt[{id1}],(patmu_pfIso03[{id2}]-patmu_chHadPtR03[{id2}])/patmu_pt[{id2}])<0.05"),
    "PTOVERM": t("dim_pt/dim_mass>0.2"),
    "NOTKPT": t("(((patmu_pfIso04[{id1}]-patmu_chHadPtR04[{id1}])/patmu_pt[{id1}]<0.2)&&((patmu_pfIso04[{id2}]-patmu_chHadPtR04[{id2}])/patmu_pt[{id2}]<0.2)||dim_pt>30)"),
    "ONEORMORENONISO": t("((dim_mu1_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/patmu_pt[{id1}])>0.1||(dim_mu2_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/patmu_pt[{id2}])>0.1)", 'at least one mu iso > 0.1'),
    "ONEMEDISO0P5": t("(((dim_mu1_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/patmu_pt[{id1}])>0.075&&(dim_mu1_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/patmu_pt[{id1}])<0.5&&(dim_mu2_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/patmu_pt[{id2}])<0.075)||((dim_mu2_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/patmu_pt[{id2}])>0.075&&(dim_mu2_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/patmu_pt[{id2}])<0.5&&(dim_mu1_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/patmu_pt[{id1}])<0.075))", 'one mu 0.075 < iso < 0.5'),
    "ONEMEDISO1P0": t("(((dim_mu1_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/patmu_pt[{id1}])>0.075&&(dim_mu1_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/patmu_pt[{id1}])<1.0&&(dim_mu2_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/patmu_pt[{id2}])<0.075)||((dim_mu2_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/patmu_pt[{id2}])>0.075&&(dim_mu2_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/patmu_pt[{id2}])<1.0&&(dim_mu1_clnd_tkiso0p3_sumPt_dz0p5_dxy0p2/patmu_pt[{id1}])<0.075))", 'one mu 0.075 < iso < 1.0'),
    "OS_ICHI2": ['OS', 'ICHI2'],
    "SS_ICHI2": ['SS', 'ICHI2'],
    "OS_CHI2": ['OS', 'CHI2'],
    "SS_CHI2": ['SS', 'CHI2'],
    "OS_ISO": ['OS', 'ISO'],
    "SS_ISO": ['SS', 'ISO'],
    "OS_IISO": ['OS', 'IISO', 'ISO0P5'],
    "SS_IISO": ['SS', 'IISO', 'ISO0P5'],
    "OS_IDPHI": ['OS', 'iDPHI'],
    "SS_IDPHI": ['SS', 'iDPHI'],
    "SS_DPHI": ['SS', 'DPHI'],
    "OS_DPHI": ['OS', 'DPHI'],
    "SS_DPHI1": ['SS', 'DPHI1'],
    "SS_DPHI4": ['SS', 'DPHI4'],
    "OS_DPHI1": ['OS', 'DPHI1'],
    "OS_DPHI4": ['OS', 'DPHI4'],
    "OS_IDPHI1": ['OS', 'IDPHI1'],
    "IDPHI_ZMASS": ['IDPHI', 'ZMASS'],
    "IDPHI_Z": ['IDPHI', 'ZMASSTIGHT'],
    "DPHI_Z": ['DPHI', 'ZMASSTIGHT'],
    "LXY0": t("dim_Lxy_pv>0.", "L_{xy} > 0 cm"),
    "LXY1": t("dim_Lxy_pv>1.", "L_{xy} > 1 cm"),
    "LXYLT0P5": t("dim_Lxy_pv<0.5", "L_{xy} < 0.5 cm"),
    "LXYLT1": t("dim_Lxy_pv<1.", "L_{xy} < 1 cm"),
    "LXYLT1GT0P5": t("dim_Lxy_pv<1.&&dim_Lxy_pv>0.5", "0.5 < L_{xy} < 1 cm"),
    "LXY2": t("dim_Lxy_pv>2.", "L_{xy} > 2 cm"),
    "LXY3": t("dim_Lxy_pv>3.", "L_{xy} > 3 cm"),
    "LXY4": t("dim_Lxy_pv>4.", "L_{xy} > 4 cm"),
    "LXY5": t("dim_Lxy_pv>5.", "L_{xy} > 5 cm"),
    "LXY6": t("dim_Lxy_pv>6.", "L_{xy} > 6 cm"),
    "LXY10": t("dim_Lxy_pv>10.", "L_{xy} > 10 cm"),
    "LXY20": t("dim_Lxy_pv>20.", "L_{xy} > 20 cm"),
    "LXY30": t("dim_Lxy_pv>30.", "L_{xy} > 30 cm"),
    "LXY40": t("dim_Lxy_pv>40.", "L_{xy} > 40 cm"),
    "LXY50": t("dim_Lxy_pv>50.", "L_{xy} > 50 cm"),
    "LXY60": t("dim_Lxy_pv>60.", "L_{xy} > 60 cm"),
    "LXYS0": t("dim_LxySig_pv>0.", "L_{xy}/#sigma_{L_{xy}} > 0"),
    "LXYS1": t("dim_LxySig_pv>1.", "L_{xy}/#sigma_{L_{xy}} > 1"),
    "LXYS2": t("dim_LxySig_pv>2.", "L_{xy}/#sigma_{L_{xy}} > 2"),
    "LXYS3": t("dim_LxySig_pv>3.", "L_{xy}/#sigma_{L_{xy}} > 3"),
    "LXYS4": t("dim_LxySig_pv>4.", "L_{xy}/#sigma_{L_{xy}} > 4"),
    "LXYS5": t("dim_LxySig_pv>5.", "L_{xy}/#sigma_{L_{xy}} > 5"),
    "LXYS6": t("dim_LxySig_pv>6.", "L_{xy}/#sigma_{L_{xy}} > 6"),
    "LXYS10": t("dim_LxySig_pv>10.", "L_{xy}/#sigma_{L_{xy}} > 10"),
    "LXYS12": t("dim_LxySig_pv>12.", "L_{xy}/#sigma_{L_{xy}} > 12"),
    "LXYS14": t("dim_LxySig_pv>14.", "L_{xy}/#sigma_{L_{xy}} > 14"),
    "LXYS15": t("dim_LxySig_pv>15.", "L_{xy}/#sigma_{L_{xy}} > 15"),
    "LXYS20": t("dim_LxySig_pv>20.", "L_{xy}/#sigma_{L_{xy}} > 20"),
    "CHI2LT5": t("dim_normChi2<5.", 'vtx #chi^{2} < 5'),
    "CHI2LT10": t("dim_normChi2<10.", 'vtx #chi^{2} < 10'),
    "CHI2LT15": t("dim_normChi2<15.", 'vtx #chi^{2} < 15'),
    "CHI2LT20": t("dim_normChi2<20.", 'vtx #chi^{2} < 20'),
    "CHI2LT30": t("dim_normChi2<30.", 'vtx #chi^{2} < 30'),
    'PTM0': t('dim_pt/dim_mass>0.', 'p_{T}/m > 0'),
    'PTM0P25': t('dim_pt/dim_mass>0.25', 'p_{T}/m > 0.25'),
    'PTM0P5': t('dim_pt/dim_mass>0.5', 'p_{T}/m > 0.5'),
    'PTM1P0': t('dim_pt/dim_mass>1.0', 'p_{T}/m > 1.0'),
    'PTM2P0': t('dim_pt/dim_mass>2.0', 'p_{T}/m > 2.0'),
    "DIFFD0": t("abs(patmu_d0sig_pv[{id1}]-patmu_d0sig_pv[{id2}])<4"),
    "DIFFPHI": t("(abs(patmu_phi[{id1}]-patmu_phi[{id2}])>3.20||abs(patmu_phi[{id1}]-patmu_phi[{id2}])<3.1)", "abs(#phi_{1}-#phi_{2}) < 3.1 || > 3.2"),
    "VSMALLDR": t("dim_deltaR<0.1"),
    "SMALLDR": t("dim_deltaR<0.2"),
    "DELTARGT0P1": t("dim_deltaR>0.1"),
    "DELTARGT1": t("dim_deltaR>1."),
    "MET": t("met_pt<100"),
    "GENLXY10TO30": t('gen_Lxy[dim_mu1_gen_idx]>=10&&gen_Lxy[dim_mu1_gen_idx]<30', '10 #leq gen L_{xy} < 30'),
    "GENLXY30TO40": t('gen_Lxy[dim_mu1_gen_idx]>=30&&gen_Lxy[dim_mu1_gen_idx]<40', '30 #leq gen L_{xy} < 40'),
    "GENLXY40TO60": t('gen_Lxy[dim_mu1_gen_idx]>=40&&gen_Lxy[dim_mu1_gen_idx]<60', '40 #leq gen L_{xy} < 60'),
    "GENLXY40": t('gen_Lxy[dim_mu1_gen_idx]>40', 'gen L_{xy} > 40'),
    "GENVERTEX": t('sqrt((gen_x[patmu_gen_idx[{id1}]]-gen_x[patmu_gen_idx[{id2}]])**2+(gen_y[patmu_gen_idx[{id1}]]-gen_y[patmu_gen_idx[{id2}]])**2)<0.0001', 'same gen vertex'),
    "GENMATCH": t('dim_mu1_gen_idx!=100&&dim_mu2_gen_idx!=100&&dim_gen_idx!=100', 'gen matched'),
    "GENACCEPTANCE": t('dim_mu1_gen_idx!=100&&dim_mu2_gen_idx!=100&&dim_gen_idx!=100&&gen_pt[dim_mu1_gen_idx]>10&&gen_pt[dim_mu2_gen_idx]>10&&abs(gen_eta[dim_mu1_gen_idx])<2.4&&abs(gen_eta[dim_mu2_gen_idx])<2.4', 'gen p_{T} > 10 |#eta|<2.4'),
    "FID": t('gen_Lxy[dim_mu1_gen_idx]<500.&&gen_z[dim_mu1_gen_idx]<800.&&gen_pt[dim_mu1_gen_idx]>10.&&gen_pt[dim_mu2_gen_idx]>10.&&abs(gen_eta[dim_mu1_gen_idx])<2.&&abs(gen_eta[dim_mu2_gen_idx])<2.'),
    "PROXGENMATCH": t('patmu_gen_idx[{id1}]!=100&&patmu_gen_idx[{id2}]!=100'),
    "MASS5": t("dim_mass>5.", "5 < mass"),
    "MASS8": t("dim_mass>8.", "8 < mass"),
    "JPSIMASS": t("dim_mass>2.9&&dim_mass<=3.3", "2.9 < mass #leq 3.3"),
    "JPSIMASSTIGHT": t("dim_mass>3.0&&dim_mass<=3.2", "3.0 < mass #leq 3.2"),
    "QCDBGMASS": t("dim_mass>2.&&dim_mass<=2.5", "2. < mass #leq 2.5"),
    "JPSIPRIME": t("dim_mass>3.5&&dim_mass<=3.7", "3.5 < mass #leq 3.7"),
    "ZMASS": t("dim_mass>60.&&dim_mass<=120.", "60 < mass #leq 120"),
    "ZMASSTIGHT": t("dim_mass>80.&&dim_mass<=100.", "80 < mass #leq 100"),
    "MASS10TO30": t("dim_mass>10.&&dim_mass<=30."),
    "MASS30TO80": t("dim_mass>30.&&dim_mass<=80."),
    "MASS80TO110": t("dim_mass>80.&&dim_mass<=110."),
    "MASS110": t("dim_mass>110."),
    "MASS1000": t("dim_mass>1000."),
    "MAXD0SIG": t("max(patmu_d0sig_pv[{id1}],patmu_d0sig_pv[{id2}])>4.0"),
    "GENLXYLT10": t("gen_Lxy[dim_mu1_gen_idx]<10.", "L_{xy} < 10 [cm]"),
    "GENLXYLT1": t("dim_mu1_gen_idx!=100&&dim_mu2_gen_idx!=100&&dim_gen_idx!=100&&gen_pt[dim_mu1_gen_idx]>10&&gen_pt[dim_mu2_gen_idx]>10&&abs(gen_eta[dim_mu1_gen_idx])<2.4&&abs(gen_eta[dim_mu2_gen_idx])<2.4&&gen_Lxy[dim_mu1_gen_idx]<1.", "L_{xy} < 1 [cm]"),
    "GENLXY3": t("dim_mu1_gen_idx!=100&&dim_mu2_gen_idx!=100&&dim_gen_idx!=100&&gen_pt[dim_mu1_gen_idx]>10&&gen_pt[dim_mu2_gen_idx]>10&&abs(gen_eta[dim_mu1_gen_idx])<2.4&&abs(gen_eta[dim_mu2_gen_idx])<2.4&&gen_Lxy[dim_mu1_gen_idx]>3.", "L_{xy} > 3 [cm]"),
    "GENLXYGT1LT10": t("dim_mu1_gen_idx!=100&&dim_mu2_gen_idx!=100&&dim_gen_idx!=100&&gen_pt[dim_mu1_gen_idx]>10&&gen_pt[dim_mu2_gen_idx]>10&&abs(gen_eta[dim_mu1_gen_idx])<2.4&&abs(gen_eta[dim_mu2_gen_idx])<2.4&&gen_Lxy[dim_mu1_gen_idx]>=1.&&gen_Lxy[dim_mu1_gen_idx]<10.", "1 #leq L_{xy} < 10 [cm]"),
    "GENLXYGT10": t("dim_mu1_gen_idx!=100&&dim_mu2_gen_idx!=100&&dim_gen_idx!=100&&gen_pt[dim_mu1_gen_idx]>10&&gen_pt[dim_mu2_gen_idx]>10&&abs(gen_eta[dim_mu1_gen_idx])<2.4&&abs(gen_eta[dim_mu2_gen_idx])<2.4&&gen_Lxy[dim_mu1_gen_idx]>=10.", "10 #leq L_{xy} [cm]"),
    "GENDRLT0P2": t("dim_mu1_gen_idx!=100&&dim_mu2_gen_idx!=100&&dim_gen_idx!=100&&gen_pt[dim_mu1_gen_idx]>10&&gen_pt[dim_mu2_gen_idx]>10&&gen_deltaR[dim_mu1_gen_idx]<0.2", "gen #Delta R < 0.2"),
    "GENDRGT0P5": t("dim_mu1_gen_idx!=100&&dim_mu2_gen_idx!=100&&dim_gen_idx!=100&&gen_pt[dim_mu1_gen_idx]>10&&gen_pt[dim_mu2_gen_idx]>10&&gen_deltaR[dim_mu1_gen_idx]>0.5", "gen #Delta R > 0.5"),
    "GENDRGT1P0": t("dim_mu1_gen_idx!=100&&dim_mu2_gen_idx!=100&&dim_gen_idx!=100&&gen_pt[dim_mu1_gen_idx]>10&&gen_pt[dim_mu2_gen_idx]>10&&gen_deltaR[dim_mu1_gen_idx]>1.0", "gen #Delta R > 1.0"),
    "HLTPPMASS": t(
        "mass(sqrt(trig_hltmu_px[{trigid1}]**2+trig_hltmu_py[{trigid1}]**2),\
        trig_hltmu_eta[{trigid1}],\
        trig_hltmu_phi[{trigid1}],\
        sqrt(trig_hltmu_px[{trigid2}]**2+trig_hltmu_py[{trigid2}]**2),\
        trig_hltmu_eta[{trigid2}],\
        trig_hltmu_phi[{trigid2}])>10".format(trigid1='patmu_hltmu_pp_idx[{id1}]', trigid2='patmu_hltmu_pp_idx[{id2}]'),
        'hlt mass > 10 GeV'
    ),
    "HLTPPCOSALPHA": t(
        "cosalpha(sqrt(trig_hltmu_px[{trigid1}]**2+trig_hltmu_py[{trigid1}]**2),\
        trig_hltmu_eta[{trigid1}],\
        trig_hltmu_phi[{trigid1}],\
        sqrt(trig_hltmu_px[{trigid2}]**2+trig_hltmu_py[{trigid2}]**2),\
        trig_hltmu_eta[{trigid2}],\
        trig_hltmu_phi[{trigid2}])>-0.8".format(trigid1='patmu_hltmu_pp_idx[{id1}]', trigid2='patmu_hltmu_pp_idx[{id2}]'),
        'hlt cos(#alpha) > -0.8'
    ),
    "HLTCOSMICMASS": t(
        "mass(sqrt(trig_hltmu_px[{trigid1}]**2+trig_hltmu_py[{trigid1}]**2),\
        trig_hltmu_eta[{trigid1}],\
        trig_hltmu_phi[{trigid1}],\
        sqrt(trig_hltmu_px[{trigid2}]**2+trig_hltmu_py[{trigid2}]**2),\
        trig_hltmu_eta[{trigid2}],\
        trig_hltmu_phi[{trigid2}])>10".format(trigid1='patmu_hltmu_cosmic_idx[{id1}]', trigid2='patmu_hltmu_cosmic_idx[{id2}]'),
        'hlt mass > 10 GeV'
    ),
    "HLTCOSMICCOSALPHA": t(
        "cosalpha(sqrt(trig_hltmu_px[{trigid1}]**2+trig_hltmu_py[{trigid1}]**2),\
        trig_hltmu_eta[{trigid1}],\
        trig_hltmu_phi[{trigid1}],\
        sqrt(trig_hltmu_px[{trigid2}]**2+trig_hltmu_py[{trigid2}]**2),\
        trig_hltmu_eta[{trigid2}],\
        trig_hltmu_phi[{trigid2}])>-0.8".format(trigid1='patmu_hltmu_cosmic_idx[{id1}]', trigid2='patmu_hltmu_cosmic_idx[{id2}]'),
        'hlt cos(#alpha) > -0.8'
    ),
    "BASE": constants.BASEPATCUTS,
    "MAXPT10": t("max(patmu_pt[{id1}],patmu_pt[{id2}])>10", "max(p_{T}) > 10 GeV"),
    "MAXPT15": t("max(patmu_pt[{id1}],patmu_pt[{id2}])>15", "max(p_{T}) > 15 GeV"),
    "MAXPT16": t("max(patmu_pt[{id1}],patmu_pt[{id2}])>16", "max(p_{T}) > 16 GeV"),
    "MAXPT20": t("max(patmu_pt[{id1}],patmu_pt[{id2}])>20", "max(p_{T}) > 20 GeV"),
    "MAXPT25": t("max(patmu_pt[{id1}],patmu_pt[{id2}])>25", "max(p_{T}) > 25 GeV"),
    "MIND0SIGPV0TO1": ['D0SIGPV0', 'ID0SIGPV1'],
    "MIND0SIGPV0TO2": ['D0SIGPV0', 'ID0SIGPV2'],
    "MIND0SIGPV0TO6": ['D0SIGPV0', 'ID0SIGPV'],
    "MIND0SIGPV2TO6": ['D0SIGPV2', 'ID0SIGPV'],
    "GEN_OR_JPSI": t('((dim_mass>2.9&&dim_mass<=3.3)||(Alt$(dim_mu1_gen_idx,100)!=100&&Alt$(dim_mu2_gen_idx,100)!=100&&Alt$(dim_gen_idx,100)!=100))', 'gen matched or 2.9 < m < 3.3'),
    "GEN_OR_IMASS5": t('((dim_mass<5)||(Alt$(dim_mu1_gen_idx,100)!=100&&Alt$(dim_mu2_gen_idx,100)!=100&&Alt$(dim_gen_idx,100)!=100))', 'gen matched or m < 5'),
    "DIMMULTGT0": t("evt_nPATSel>0", "dim. multiplicity #geq 1"),
    "DIMMULTGT1": t("evt_nPATSel>1", "dim. multiplicity #geq 2"),
    "SRCUTS": ["BASE", "OS"],
    "SRCUTS_JPSI": ["REP", "LXYE", "CHI2", "COSA", "DCA", "PXL", "DPHI", "HB4V", "NTRKLAYSLXY", "OS", "PT23"],
    "SRCUTS_JPSI_TRIG": ["REP", "LXYE", "CHI2", "COSA", "DCA", "PXL", "DPHI", "HB4V", "NTRKLAYSLXY", "OS", "PT23", "HLTDisplacedL3"],
    "DATACUTS_JPSI": ["REP", "LXYE", "ONEORMORENONISO", "CHI2", "COSA", "DCA", "PXL", "DPHI", "HB4V", "NTRKLAYSLXY", "OS", "JPSIMASSTIGHT", "PT23"],
    "DATACUTS_JPSI_TRIG": ["REP", "LXYE", "ONEORMORENONISO", "CHI2", "COSA", "DCA", "PXL", "DPHI", "HB4V", "NTRKLAYSLXY", "OS", "JPSIMASSTIGHT", "PT23", "HLTDisplacedL3"],
    "GENRECOVTXMATCH": t("sqrt((gen_x[dim_mu1_gen_idx]-dim_x)**2+(gen_y[dim_mu1_gen_idx]-dim_y)**2+(gen_z[dim_mu1_gen_idx]-dim_z)**2)<10.")
}

# Add PAT-PAT mass windows
for mass in PATPAT_MASS_WIDTHS:
    low = mass - PATPAT_MASS_WIDTHS[mass]
    high = mass + PATPAT_MASS_WIDTHS[mass]
    patdimdict['MASSWIN_{}'.format(str(int(mass)))] = t("dim_mass>{low}&&dim_mass<{high}".format(low=low, high=high), "{low} < mass < {high}".format(low=low, high=high))

# Add RPV-SUSY PAT-PAT mass windows
for mass in [50, 100, 150, 175, 325, 500, 675, 950, 1125, 1400, 1575]:
    low = int(mass * 0.6)
    high = int(mass * 1.1)
    patdimdict['SUSYMASSWIN_{}'.format(str(int(mass)))] = t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>{low}&&correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)<{high}".format(low=low, high=high), "{low} < Corrected mass < {high}".format(low=low, high=high))

# Add RPV-SUSY PAT-PAT mass windows
for mass in [50, 100, 150, 175, 325, 500, 675, 950, 1125, 1400, 1575]:
    low = int(mass * 0.6)
    high = int(mass * 1.1)
    patdimdict['SUSYMASSWIN_{}'.format(str(int(mass)))] = t("correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)>{low}&&correctedmass(dim_mass,dim_p,dim_pt,dim_eta,dim_phi,dim_x-vtx_pv_x,dim_y-vtx_pv_y,dim_z-vtx_pv_z)<{high}".format(low=low, high=high), "{low} < Corrected mass < {high}".format(low=low, high=high))

# Event Cuts
evtdict = {
    "HLTPPCOSMIC": t("(evt_dsa_hltmatch_pp==1||evt_dsa_hltmatch_cosmic==1)"),
    "HLTRun3": t("(evt_dsa_hltmatch_pp==1||evt_dsa_hltmatch_cosmic==1||evt_dsa_hltmatch_ppseed||evt_dsa_hltmatch_cosmicseed||evt_dsa_hltmatch_ppseed_L3veto||evt_dsa_hltmatch_cosmicseed_L3veto||evt_dsa_hltmatch_hybrid||evt_dsa_hltmatch_ppseed_doubleL3||evt_dsa_hltmatch_purepp||evt_dsa_hltmatch_purecosmic||evt_dsa_hltmatch_ppseed_er2p4||evt_dsa_hltmatch_cosmicseed_er2p4)"),
    "HLTPP": t("evt_dsa_hltmatch_pp==1"),
    "HLTPUREPP": t("evt_dsa_hltmatch_pp==1&&evt_dsa_hltmatch_cosmic==0"),
    "HLTCOSMIC": t("evt_dsa_hltmatch_cosmic==1"),
    "HLTPURECOSMIC": t("evt_dsa_hltmatch_cosmic==1&&evt_dsa_hltmatch_pp==0"),
    "HIP": yt({
        2016: t("evt_run<=278802", 'HIP Effect Region'),
        2018: t("0", 'HIP Effect Region'),
        2022: t("0", 'HIP Effect Region')
    }),
    "HLTPAT": yt({
        2022: t("(evt_dsa_hltmatch_ppseed==1||evt_dsa_hltmatch_cosmicseed==1||evt_dsa_hltmatch_ppseed_doubleL3==1)")
    }),

    "HLTRun2": yt({
        2018: t("1", 'Run 2 paths'),
        2022: t("(evt_dsa_hltmatch_ppseed==1||evt_dsa_hltmatch_cosmicseed==1)", 'Run 2 (2018)')
    }),
    #                                                         2022: Cut("(Sum$(strstr(trig_hlt_path,\"HLT_DoubleL2Mu23NoVtx_2Cha_v\"))||Sum$(strstr(trig_hlt_path,\"HLT_DoubleL2Mu23NoVtx_2Cha_CosmicSeed_v\")))", 'Run 2 (2018)')}),
    "L1TRun2": yt({
        2018: t("1", 'Run 2 L1 Triggers'),
        2022: t("(evt_l1trigger_L1_DoubleMu_15_7==1||evt_l1trigger_L1_DoubleMu_15_5_SQ==1||evt_l1trigger_L1_TripleMu_5_3_3==1)", 'Run 2 L1 Triggers')
    }),
    "L1TRun3": t("1", '2022 L1T Configuration'),
    "L1TRun3_UptBMTFOnly": t(
        "(evt_l1trigger_L1_DoubleMu_15_7==1||\
        evt_l1trigger_L1_DoubleMu_15_5_SQ==1||\
        evt_l1trigger_L1_TripleMu_5_3_3==1||\
        (evt_l1trigger_L1_DoubleMu0_Upt15_Upt7==1&&abs(trig_l1tmu_eta)<0.83)||\
        (evt_l1trigger_L1_DoubleMu0_Upt6_IP_Min1_Upt4==1&&abs(trig_l1tmu_eta)<0.83)||\
        evt_l1trigger_L1_DoubleMu0er1p5_SQ_OS_dR_Max1p4==1||\
        evt_l1trigger_L1_DoubleMu4p5_SQ_OS_dR_Max1p2==1)",
        'Run 3 2022 L1T Configuration'
    ),
    "L1TRun2_Upt": t("(evt_l1trigger_L1_DoubleMu0_Upt15_Upt7==1||evt_l1trigger_L1_DoubleMu_15_7==1||evt_l1trigger_L1_DoubleMu_15_5_SQ==1||evt_l1trigger_L1_TripleMu_5_3_3==1)", 'L1 2018 OR L1_DoubleMu0_Upt15_Upt7'),
    "L1TRun3_Upt": t("(evt_l1trigger_L1_DoubleMu0_Upt15_Upt7==1||evt_l1trigger_L1_DoubleMu0_Upt6_IP_Min1_Upt4==1)", 'L1_DoubleMu0_Upt15_Upt7 OR L1_DoubleMu0_Upt6_IP_Min1_Upt4'),
    "L1TRun3_Upt15_7": t("(evt_l1trigger_L1_DoubleMu0_Upt15_Upt7==1||)", 'L1_DoubleMu0_Upt15_Upt7'),
    "L1TRun3_Upt6_4": t("(evt_l1trigger_L1_DoubleMu0_Upt6_IP_Min1_Upt4==1||)", 'L1_DoubleMu0_Upt6_IP_Min1_Upt4'),
    "L1TRun3_BPh": t("(evt_l1trigger_L1_DoubleMu0er1p5_SQ_OS_dR_Max1p4||evt_l1trigger_L1_DoubleMu4p5_SQ_OS_dR_Max1p2)", 'Run 3 L1 BPhysics Triggers'),
    "Run3_2018": ['HLTRun2', 'L1TRun2'],
    "HLTRun2PP": yt({
        2022: t("(evt_dsa_hltmatch_ppseed==1)", 'Run 2 (2018)')
    }),
    "HLTRun2COSMIC": yt({
        2022: t("(evt_dsa_hltmatch_cosmicseed==1)", 'Run 2 (2018)')
    }),
    "HLTCOSMICL3Veto": yt({
        2022: t("evt_hltrigger_cosmicseed_L3veto==1", 'Run 3 (2022, L2)')
    }),
    "HLTPPL3Veto": yt({
        2022: t("evt_hltrigger_ppseed_L3veto==1", 'Run 3 (2022, L2)')
    }),
    "HLTL3VetoOR": yt({
        2022: t("(evt_hltrigger_cosmicseed_L3veto==1||evt_hltrigger_ppseed_L3veto==1)", 'Run 3 (2022, L2)')
    }),
    "HLT2022OR": yt({
        2022: t("(evt_hltrigger_cosmicseed_L3veto==1||evt_hltrigger_ppseed_L3veto==1||evt_hltrigger_ppseed_doubleL3||evt_dsa_hltmatch_ppseed==1||evt_dsa_hltmatch_cosmicseed==1)", 'Run 3 (2022)')
    }),
    #            "HLTDisplacedL3"         : yt({2022: Cut("evt_hltrigger_ppseed_doubleL3==1", 'Run 3 (2022, L3)')}),
    "HLTDisplacedL3": yt({
        2022: t("Sum$(strstr(trig_hlt_path,\"HLT_DoubleL3Mu16_10NoVtx_DxyMin0p01cm_v\"))", 'Run 3 (2022, L3)')
    }),
    "HLTPPL3Veto": yt({
        2022: t("evt_dsa_hltmatch_ppseed_L3veto==1", 'PP seed + prompt L3 veto')
    }),
    #            "HLTCOSMICL3Veto"        : yt({2022: Cut("evt_dsa_hltmatch_cosmicseed_L3veto==1", 'Cosmic seed + prompt L3 veto')}),
    #            "HLTDisplacedL3"         : yt({2022: Cut("evt_dsa_hltmatch_ppseed_doubleL3==1", 'DoubleL3MuDxy0p1')}),

    #            "UptAddEMTF"           : yt({2022: Cut("(evt_l1trigger_L1_DoubleMu_15_7==1||evt_l1trigger_L1_DoubleMu_15_5_SQ==1||evt_l1trigger_L1_TripleMu_5_3_3==1||evt_l1trigger_L1_DoubleMu0er1p5_SQ_OS_dR_Max1p4||evt_l1trigger_L1_DoubleMu4p5_SQ_OS_dR_Max1p2||evt_l1trigger_L1_DoubleMu0_Upt15_Upt7||((evt_l1trigger_L1_DoubleMu0_Upt6_IP_Min1_Upt4)&&(abs(dsamu_eta[dim_mu1_idx])<0.82&&abs(dsamu_eta[dim_mu2_idx])<0.82)))", 'Run 3 triggers, but with Upt restricted to Barrel')}),
    "UptAddEMTF": yt({
        2022: t("(evt_l1trigger_L1_DoubleMu_15_7==1||evt_l1trigger_L1_DoubleMu_15_5_SQ==1||evt_l1trigger_L1_TripleMu_5_3_3==1||evt_l1trigger_L1_DoubleMu0er1p5_SQ_OS_dR_Max1p4||evt_l1trigger_L1_DoubleMu4p5_SQ_OS_dR_Max1p2||(evt_l1trigger_L1_DoubleMu0_Upt15_Upt7||(evt_l1trigger_L1_DoubleMu0_Upt15_Upt7||evt_l1trigger_L1_DoubleMu0_Upt6_IP_Min1_Upt4)&&(abs(dsamu_eta[dim_mu1_idx])<0.82&&abs(dsamu_eta[dim_mu2_idx])<0.82)))", 'Run 3 triggers, but with Upt restricted to Barrel')
    }),
    "UptKBMTF": yt({
        2022: t("(evt_l1trigger_L1_DoubleMu_15_7==1||evt_l1trigger_L1_DoubleMu_15_5_SQ==1||evt_l1trigger_L1_TripleMu_5_3_3==1||evt_l1trigger_L1_DoubleMu0er1p5_SQ_OS_dR_Max1p4||evt_l1trigger_L1_DoubleMu4p5_SQ_OS_dR_Max1p2||((evt_l1trigger_L1_DoubleMu0_Upt15_Upt7||evt_l1trigger_L1_DoubleMu0_Upt6_IP_Min1_Upt4)&&(abs(dsamu_eta[dim_mu1_idx])<0.82&&abs(dsamu_eta[dim_mu2_idx])<0.82)))", 'Run 3 triggers, but with Upt restricted to Barrel')
    }),
}
